package com.cnd3b.common.restful;

import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.D3BReturnObject_Err;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DBConnect;
import com.cnd3b.common.data.db.DataPool;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.restcontroller.publicmethod.users.Users;
import com.cnd3b.restcontroller.system.system.uploadExcelData;
import com.cnd3b.utility.Encryption;
import com.cnd3b.utility.Sms;
import com.cnd3b.utility.sysmsg;
import com.cnd3b.utility.wechatpay.apppay.POJO.APPQueryOrderRequest;
import com.cnd3b.utility.wechatpay.apppay.POJO.AppWechatOrder;
import com.cnd3b.utility.wechatpay.apppay.apppay;
import com.cnd3b.utility.wechatpay.jsapipay.POJO.JSQueryOrderRequest;
import com.cnd3b.utility.wechatpay.jsapipay.POJO.JSWechatOrder;
import com.cnd3b.utility.wechatpay.jsapipay.jsapipay;
import com.cnd3b.utility.wechatpay.nativepay.nativepay;
import net.polyv.live.v1.util.LiveSignUtil;
import org.dom4j.dom.DOMElement;
import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.io.InputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Random;

@Path("webclientrest")
public class WebClientRest {

    private static String[] nocheckphonenumber = {"13732579910"};

    @POST
    public String method(@Context HttpServletRequest request, String RequestContent) {
        if (RequestContent == null || RequestContent.equals("")) {
            return new D3BReturnObject_Err().setErrMsg("ĸʽ󣬱ΪJSONObjectʽ").toString();
        }
        /**
         * ֤ǷΪ淶SONObjectʽ
         */
        JSONObject requestcontent = null;
        try {
            requestcontent = JSONObject.parseObject(RequestContent);
        } catch (Exception e) {
            return new D3BReturnObject_Err().setErrMsg("ĸʽ󣬱ΪJSONObjectʽ").toString();
        }
        /**
         * ֤Ƿļֵ
         */
        String[] mustkeys = {"classname", "method", "content"};
        for (String mustkey : mustkeys) {
            if (!requestcontent.containsKey(mustkey)) {
                return new D3BReturnObject_Err().setErrMsg("jsonȱKEY" + mustkey).toString();
            }
        }
        /**
         * ֤еcontentǷΪ淶SONObjectʽ
         */
        JSONObject content = new JSONObject();
        try {
            content = requestcontent.getJSONObject("content");
        } catch (Exception e) {
            return new D3BReturnObject_Err().setErrMsg("contentʽ󣬱ΪJSONObjectʽ").toString();
        }

        /**
         * ֤еtokenǷЧ
         */
        String accesstoken = "";
        String className = requestcontent.getString("classname");
        if (!className.contains("publicmethod")) {
            if (!requestcontent.containsKey("accesstoken")) {
                return new D3BReturnObject_Err().setErrCode(-1).setErrMsg("½״̬ѹڣµ½").toString();
            }
            accesstoken = requestcontent.getString("accesstoken");
            /**
             * ̵㵱ǰ˺ǷЧtoken
             */
            if (!parameter.tokenlist.containsKey(accesstoken) && !istokeninuserlist(accesstoken)) {
                //вڣ˺бнвѯ鵽󣬽tokne뻺
                return new D3BReturnObject_Err().setErrCode(-1).setErrMsg("½״̬ѹڣµ½").toString();
            }
            parameter.requesttime.put(accesstoken, Calendar.getInstance().getTime());
        }

        String methodName = requestcontent.getString("method");
        if (content.isEmpty()) {
            content = new JSONObject();
        }
        content.put("$classname", className);
        content.put("$method", methodName);
        content.put("$accesstoken", accesstoken);
        content.put("$requestHost", request.getScheme() + "://" + request.getHeader("Host"));

        String key = className + "." + methodName;
        String result;
        Object obj = null;
        try {
            boolean getdatafromdbanyway = content.containsKey("getdatafromdbanyway")
                    && content.getBoolean("getdatafromdbanyway");
            content.remove("getdatafromdbanyway");
            Object data = null;
            if (!getdatafromdbanyway) {
                data = DataPool.get(content.toString());
            }
            if (data != null) {
                result = data.toString();
                saveCallMethodMsg(key, false, 0L);
            } else {
                long starttimes = Calendar.getInstance().getTimeInMillis();
                /**
                 * ִ󷽷
                 */
                Class clz = Class.forName("com.cnd3b.restcontroller." + className);
                Constructor cla = clz.getDeclaredConstructor(JSONObject.class);
                obj = cla.newInstance(content);
                Method method = obj.getClass().getDeclaredMethod(methodName);
                result = (String) method.invoke(obj);
                long endtimes = Calendar.getInstance().getTimeInMillis();
                saveCallMethodMsg(key, true, endtimes - starttimes);
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("Ҳָ" + className).toString();
        } catch (InstantiationException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "ʵ쳣").toString();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "ȫȨ쳣ܸΪpublic").toString();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("Ҳָ" + className + "" + methodName + "").toString();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "" + methodName + "Ϸ").toString();
        } catch (InvocationTargetException e) {
            Throwable targetException = e.getTargetException();
            targetException.printStackTrace();
            D3BReturnObject_Err d3BReturnObject_err = new D3BReturnObject_Err();
            d3BReturnObject_err.setErrMsg(targetException.getMessage());
            result = d3BReturnObject_err.toString();
        } catch (Exception e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("δ֪쳣" + e.getMessage()).toString();
        } finally {
            if (obj != null) {
                try {
                    obj.getClass().getMethod("p2ServerSystemPaoSetClose").invoke(obj);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        return result;
    }


    public boolean istokeninuserlist(String accesstoken) {
        DBConnect dbConnect = new DBConnect();
        SQLFactory factory = new SQLFactory(this, "־û˺бѯ");
        factory.addParameter("accesstoken", accesstoken);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        if (rows.isEmpty()) {
            return false;
        } else {
            for (Row row : rows) {
                long userid = row.getLong("userid");
                String token = row.getString("token");
                row.put("logintime", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Calendar.getInstance().getTime()));
                parameter.userIdList.put(userid, row);
                parameter.tokenlist.put(token, userid);
            }
            return true;
        }
    }

    /**
     * ¼
     *
     * @param key
     * @param fromdb
     * @param time
     */
    private void saveCallMethodMsg(String key, boolean fromdb, long time) {
        long callmethodTimes = parameter.callmethodTimes.containsKey(key) ? parameter.callmethodTimes.get(key) : 0L;

        //
        parameter.callmethodTimes.put(key, callmethodTimes + 1L);

        //ʱ
        parameter.lastcallmethodtime.put(key, Calendar.getInstance().getTime());

        //ӻȡĴ
        long callmethod_fromcacheTimes = parameter.callmethod_fromcacheTimes.containsKey(key) ? parameter.callmethod_fromcacheTimes.get(key) : 0L;
        if (!fromdb) {
            /**
             * ӻȡ
             */
            parameter.callmethod_fromcacheTimes.put(key, callmethod_fromcacheTimes + 1L);
        } else {
            /**
             * ѯºʱ
             */
            parameter.callmethodLastTimeLong.put(key, time);


            long totaltimes = callmethodTimes - callmethod_fromcacheTimes;

            /**
             * ѯƽʱ
             */
            long callmethodTimeLong = parameter.callmethodTimeLong.containsKey(key) ? parameter.callmethodTimeLong.get(key) : 0L;

            parameter.callmethodTimeLong.put(key, (callmethodTimeLong * totaltimes + time) / (totaltimes + 1));
        }
    }

    /**
     * ȡŵ½֤
     *
     * @param RequestContent
     * @return
     */
    @Path("getpassword")
    @POST
    public String getPassWord(@Context HttpServletRequest request, String RequestContent) {
        /**
         * ֤ǷΪ淶SONObjectʽ
         */
        JSONObject requestcontent = null;
        try {
            requestcontent = JSONObject.parseObject(RequestContent);
        } catch (Exception e) {
            return new D3BReturnObject_Err().setErrMsg("ĸʽ󣬱ΪJSONObjectʽ").toString();
        }
        /**
         * ֤Ƿļֵ
         */
        String[] mustkeys = {"phonenumber"};
        for (String mustkey : mustkeys) {
            if (!requestcontent.containsKey(mustkey)) {
                return new D3BReturnObject_Err().setErrMsg("jsonȱKEY" + mustkey).toString();
            }
        }
        String phonenumber = requestcontent.getString("phonenumber");
        String client = "";//½Դweb_manageweb_customerwechat_customer
        if (requestcontent.containsKey("client")) {
            client = requestcontent.getString("client");
            if ("web_manage".equalsIgnoreCase(client)) {
                DBConnect dbConnect = new DBConnect();
                if (dbConnect.runSqlQuery("select * from tenterprise_users where fphonenumber='" + phonenumber + "' and fusertype='ҵ'").isEmpty()) {
                    JSONObject object = new JSONObject();
                    object.put("code", 0);
                    object.put("msg", "ǰֻŲǹԱ˺");
                    return object.toString();
                }
            }
        }

        String password = createPassWord();
        parameter.phonenumber_password.put(phonenumber, password);
        parameter.password_client.put(password, client);
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.MINUTE, 5);
        parameter.phonenumber_date.put(phonenumber, calendar.getTime());

        if (parameter.isdebug()) {
            JSONObject object = new JSONObject();
            object.put("code", 1);
            object.put("msg", "ֻ֤Ϊ" + password);
            System.err.println("ֻ֤Ϊ" + password);
            return object.toString();
        } else {
            JSONObject object = new JSONObject();
            Sms sms = new Sms();
            sms.sendOutMsg(phonenumber, password);
            object.put("code", 1);
            object.put("msg", "ֻ֤ѷͣעգ");
            return object.toString();
        }
    }

    /**
     * ֤
     *
     * @return
     */
    public String createPassWord() {
        String allChar = "1234567890";
        StringBuffer sb = new StringBuffer();
        Random random = new Random();
        for (int i = 0; i < 6; i++) {
            sb.append(allChar.charAt(random.nextInt(allChar.length())));
        }
        if (parameter.phonenumber_password.containsValue(sb.toString())) {
            return createPassWord();
        } else {
            return sb.toString();
        }
    }

    @Path("login")
    @POST
    public String login(String RequestContent) {
        /**
         * ֤ǷΪ淶SONObjectʽ
         */
        JSONObject requestcontent = null;
        try {
            requestcontent = JSONObject.parseObject(RequestContent);
        } catch (Exception e) {
            return new D3BReturnObject_Err().setErrMsg("ĸʽ󣬱ΪJSONObjectʽ").toString();
        }
        /**
         * ֤Ƿļֵ
         */
        String[] mustkeys = {"phonenumber", "password"};
        for (String mustkey : mustkeys) {
            if (!requestcontent.containsKey(mustkey)) {
                return new D3BReturnObject_Err().setErrMsg("jsonȱKEY" + mustkey).toString();
            }
        }
        String phonenumber = requestcontent.getString("phonenumber");
        String password = requestcontent.getString("password");

        String login_client_ = "";//½Դweb_manageweb_customerwechat_customer
        if (requestcontent.containsKey("client")) {
            login_client_ = requestcontent.getString("client");
        }

        String password_client_ = "";//½Դweb_manageweb_customerwechat_customer
        int resultcode;
        DBConnect connect = new DBConnect();
        if (!parameter.phonenumber_password.containsKey(phonenumber)) {
            resultcode = 1;//ûлȡ֤
        } else if (parameter.phonenumber_date.get(phonenumber).before(Calendar.getInstance().getTime())) {
            resultcode = 2;//֤ʧЧ
        } else {
            //ϵͳ֤
            String syspassword = parameter.phonenumber_password.get(phonenumber);
            if (password.equals(new Encryption().Encode_MD5(syspassword))) {
                resultcode = 0;//֤ȷ
                password_client_ = parameter.password_client.get(syspassword);
                if (!login_client_.equals(password_client_)) {
                    resultcode = 4;
                }
            } else {
                resultcode = 3;//֤
            }
        }
        boolean isweb_manage = login_client_.equals("web_manage");//Ƿ˵½
        int isnewregister = 0;
        if (resultcode == 0 || Arrays.asList(nocheckphonenumber).contains(phonenumber)) {
            if (!isweb_manage) {
                //½ʱ֤֤ɹֻδעԶעᣡ
                if (connect.runSqlQuery("select * from tenterprise_users where fisused=1 and fusertype='' and fphonenumber='" + phonenumber + "'").isEmpty()) {
                    Users users = new Users(requestcontent);
                    users.register_usersByLogin(phonenumber, parameter.defaultsiteid);
                    isnewregister = 1;
                }
            }
            //web˵½
            SQLFactory factory = new SQLFactory(this, isweb_manage ? "ֻ˺бѯ" : "ͻֻ˺бѯ");
            factory.addParameter("fphonenumber", phonenumber);
            Rows rows = connect.runSqlQuery(factory.getSQL());

            ArrayList<String> tokensaveList = new ArrayList<>();
            for (Row row : rows) {
                long userid = row.getLong("userid");
                String siteid = row.getString("siteid");
                String usertoken = new Encryption().Encode_MD5(phonenumber + password + userid + Calendar.getInstance().getTimeInMillis());
                row.put("token", usertoken);
                row.put("logintime", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Calendar.getInstance().getTime()));
                row.put("isnewregister", isnewregister);

                SQLFactory headportraitSQL = new SQLFactory("ѯ_");
                headportraitSQL.addParameter("ownertable", "tenterprise_users");
                headportraitSQL.addParameter_in("ownerid", userid);
                headportraitSQL.addParameter("siteid", siteid);
                headportraitSQL.addParameter("ftype", "headportrait");
                row.put("attinfos", headportraitSQL.runSqlQuery());

                parameter.userIdList.put(userid, row);
                parameter.tokenlist.put(usertoken, userid);

                tokensaveList.add("update tenterprise_users set accesstoken='" + usertoken + "' where tenterprise_userid=" + userid);
            }
            if (!tokensaveList.isEmpty()) {
                /**
                 * ˺ŵ¼̬־û
                 */
                connect.runSqlUpdate(tokensaveList);
            }
            JSONObject object = new JSONObject();
            object.put("code", 1);
            object.put("msg", "ɹ");
            object.put("webclienturl", "https://www.buwanjia.com/customer/index.html");
            object.put("servicehotline", "13157370035");
            object.put("account_list", rows.toJsonArray());

            //¼ɹ֤ʧЧ
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.MINUTE, -5);
            parameter.phonenumber_date.put(phonenumber, calendar.getTime());
            return object.toString();
        } else {
            String msg = "";
            if (resultcode == 1) {
                msg = "Ȼȡֻ֤룡";
            } else if (resultcode == 2) {
                msg = "֤ʧЧ»ȡ";
            } else if (resultcode == 3 || resultcode == 4) {
                msg = "Ч֤룡";
            }
            JSONObject object = new JSONObject();
            object.put("code", 0);
            object.put("msg", msg);
            return object.toString();
        }
    }


    @Path("logout")
    @POST
    public String logout(String RequestContent) {
        /**
         * ֤ǷΪ淶SONObjectʽ
         */
        JSONObject requestcontent = null;
        try {
            requestcontent = JSONObject.parseObject(RequestContent);
        } catch (Exception e) {
            return new D3BReturnObject_Err().setErrMsg("ĸʽ󣬱ΪJSONObjectʽ").toString();
        }
        /**
         * ֤Ƿļֵ
         */
        String[] mustkeys = {"accesstoken"};
        for (String mustkey : mustkeys) {
            if (!requestcontent.containsKey(mustkey)) {
                return new D3BReturnObject_Err().setErrMsg("jsonȱKEY" + mustkey).toString();
            }
        }
        /**
         * ֤еtokenǷЧ
         */
        String accesstoken = requestcontent.getString("accesstoken");
        parameter.tokenlist.remove(accesstoken);
        new DBConnect().runSqlUpdate("update tenterprise_users set accesstoken=null where accesstoken='" + accesstoken + "'");
        JSONObject object = new JSONObject();
        object.put("status", "ok");
        return object.toString();
    }


    /**
     * ݵ
     *
     * @param uploadfileInputStream
     * @param uploadfile
     * @param userid
     * @param accesstoken
     * @param ftype
     * @return
     */
    @Path("uploadexcel")
    @POST
    @Consumes({"multipart/form-data"})
    @Produces({"application/json"})
    public String upLoadDoc(@FormDataParam("uploadfile") InputStream uploadfileInputStream,
                            @FormDataParam("uploadfile") FormDataContentDisposition uploadfile,
                            @FormDataParam("userid") String userid,
                            @FormDataParam("accesstoken") String accesstoken, @FormDataParam("ftype") String ftype) {
        /**
         * ֤еtokenǷЧ
         */
        if (!parameter.tokenlist.containsKey(accesstoken)) {
            return new D3BReturnObject_Err().setErrCode(-1).setErrMsg("½״̬ѹڣµ½").toString();
        }
        JSONObject content = new JSONObject();
        content.put("userid", userid);
        uploadExcelData uploadExcelData = new uploadExcelData(content);
        return uploadExcelData.upLoadExcel(uploadfileInputStream, uploadfile, ftype);
    }

    /**
     * ΢֧صӿ
     *
     * @param RequestContent
     * @return
     */
    @POST
    @Path("wechatpay/returnorderstateapp")
    public String wechatpayapp(String RequestContent) {

        APPQueryOrderRequest queryOrderRequest = new APPQueryOrderRequest();
        AppWechatOrder order = queryOrderRequest.getWechatOrder(RequestContent);
        apppay apppay = new apppay();
        boolean success = apppay.updateLocalOrder(order);
        DOMElement request = new DOMElement("xml");
        request.addElement("return_code").addText(success ? "SUCCESS" : "FAIL");
        request.addElement("return_msg").addText(success ? "OK" : "Уʧ");
        return request.asXML();
    }

    /**
     * ΢ҳ֧صӿ
     *
     * @param RequestContent
     * @return
     */
    @POST
    @Path("wechatpay/returnorderstatenative")
    public String wechatpaynative(String RequestContent) {
        nativepay nativepay = new nativepay();
        JSONObject returnobject = JSONObject.parseObject(RequestContent);
        boolean success = nativepay.updateLocalOrder_callback(returnobject);
        JSONObject request = new JSONObject();
        request.put("code", success ? "SUCCESS" : "FAIL");
        request.put("message", success ? "ɹ" : "Уʧ");
        return request.toString();
    }

    /**
     * ΢ҳ֧صӿ
     *
     * @param RequestContent
     * @return
     */
    @POST
    @Path("wechatpay/returnorderstatejs")
    public String wechatpayjs(String RequestContent) {

        JSQueryOrderRequest queryOrderRequest = new JSQueryOrderRequest();
        JSWechatOrder order = queryOrderRequest.getWechatOrder(RequestContent);
        jsapipay jsapipay = new jsapipay();
        boolean success = jsapipay.updateLocalOrder(order);
        DOMElement request = new DOMElement("xml");
        request.addElement("return_code").addText(success ? "SUCCESS" : "FAIL");
        request.addElement("return_msg").addText(success ? "OK" : "Уʧ");
        return request.asXML();
    }

    @Path("sysmsg")
    @GET
    @Produces(MediaType.TEXT_HTML)
    @Consumes(MediaType.TEXT_HTML)
    public String sysmsg() throws JSONException {
        return new sysmsg().getCustMsg();
    }

    @GET
    @Path("polyvAuth")
    public String polyvAuth(@QueryParam("channelId") String channelId, @QueryParam("userid") String userid, @QueryParam("ts") Long ts, @QueryParam("token") String token) {
        JSONObject result = new JSONObject();
        long timeMillis = System.currentTimeMillis();
        long diffTime = Math.abs(timeMillis - ts);
        //1ʱж
        if (diffTime > 5 * 60 * 1000) {
            result.put("status", "0");
            //׳쳣ʱerrorUrlת errorUrl ,δ errorUrlȲѯ ⲿȨ
            // externalRedirectUriexternalRedirectUriΪתexternalRedirectUriַexternalRedirectUriΪתĬҳ
            result.put("errorUrl", "https://www.polyv.net");
            return result.toJSONString();
        }

        //2ǩж
        DBConnect dbConnect = new DBConnect();
        Rows rows = dbConnect.runSqlQuery("select secretkey from tlive where channelId='" + channelId + "'");
        if (rows.isEmpty()) {
            result.put("errorUrl", "https://www.polyv.net");
            return result.toJSONString();
        }
        String signText = rows.get(0).getString("secretkey") + userid + rows.get(0).getString("secretkey") + ts;
        String sign = null;
        try {
            sign = LiveSignUtil.md5Hex(signText);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (sign == null || !sign.equals(token)) {
            result.put("status", "0");
            //׳쳣ʱerrorUrlת errorUrl ,δ errorUrlȲѯ ⲿȨ
            // externalRedirectUriexternalRedirectUriΪתexternalRedirectUriַexternalRedirectUriΪתĬҳ
            result.put("errorUrl", "https://www.polyv.net");
            return result.toJSONString();
        }
        // ҵ߼ݾݿ
        //3
        Rows userrows = dbConnect.runSqlQuery("select *from tenterprise_users where tenterprise_userid='" + userid + "'");
        if (userrows.isEmpty()) {
            result.put("status", "0");
            //׳쳣ʱerrorUrlת errorUrl ,δ errorUrlȲѯ ⲿȨ
            // externalRedirectUriexternalRedirectUriΪתexternalRedirectUriַexternalRedirectUriΪתĬҳ
            result.put("errorUrl", "https://www.polyv.net");
            return result.toJSONString();
        }
        result.put("status", "1");
        result.put("userid", userid);
        result.put("nickname", userrows.get(0).getString("fname"));
        result.put("marqueeName", "ֱ");
        // result.put("actor", "ѧ");
        result.put("actorFColor", "#2469f3");
        result.put("actorBgColor", null);
        result.put("param4", null);
        result.put("param5", null);
        result.put("avatar", "http://dev.polyv.net/favicon.ico");
        return result.toJSONString();
    }
}
