package com.cnd3b.restcontroller.customer.products;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;

public class products extends Controller {

    /**
     * 캯
     *
     * @param content
     */
    public products(JSONObject content) {
        super(content);
    }

    /**
     * Ʒбѯ
     *
     * @return
     */
    public String query_productsList() {
        /**
         *
         */
        String[] sortfield = {"t1.fisonsale desc,t1.fonsaledate desc,t1.createdate desc"};
        String sort = getSort(sortfield, "t1.fisonsale desc,t1.fonsaledate desc,t1.createdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fprodname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fprodnum like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fintroduction like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftag like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fisonsale") && !"".equals(whereObject.getString("fisonsale"))) {
                if (whereObject.getBooleanValue("fisonsale")) {
                    where.append(" and t1.fisonsale=1 ");
                } else {
                    where.append(" and t1.fisonsale=0 ");
                }
            }
        }
        SQLFactory sql = new SQLFactory(this, "Ʒбѯ", pageSize, pageNumber, sort);
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", tagentsid);
        sql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap tagents_productMap = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", tagents_productMap.get(row.getString("tagents_productid")));
            row.put("ftag", JSONArray.parseArray(row.getString("ftag")));
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).saveToDataPool().toString();
    }

    /**
     * Ʒѯ
     *
     * @return
     */
    public String query_productsMain() {
        SQLFactory sql = new SQLFactory(this, "Ʒѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", tagentsid);
        sql.addParameter("tagents_productid", content.getLong("tagents_productid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap tagents_productMap = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", tagents_productMap.get(row.getString("tagents_productid")));
            row.put("ftag", JSONArray.parseArray(row.getString("ftag")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ʒ޸
     *
     * @return
     */
    public String insertOrModifyProducts() throws D3bException, P2Exception {
        long tagents_productid = content.getLongValue("tagents_productid");//ƷIDʱ0
        String fprodnum = content.getString("fprodnum", "tagents_product.fprodnum", "Ʒ");
        String fprodname = content.getString("fprodname", "tagents_product.fprodname", "Ʒ");
        double fprice = content.getDoubleValue("fprice");
        String fprodclassname = content.getString("fprodclassname", "tagents_product.fprodclassname", "ӪĿ");
        String fintroduction = content.getString("fintroduction", "tagents_product.fintroduction", "Ʒ");
        String fnotes = content.getString("fnotes", "tagents_product.fnotes", "ע");
        //String ftag = content.getString("ftag", "tagents_product.ftag", "ǩ");
        boolean fisonsale = content.getBoolean("fisonsale");
//        if (!isJSONArray(ftag)) {
//            return new D3BReturnObject_Err().setErrMsg("ftagЧJSONArrayʽ").toString();
//        }
        PaoSetRemote tagents_productSet = getP2ServerSystemPaoSet("tagents_product", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tagents_productid='" + tagents_productid + "'");
        PaoRemote tagents_product = null;
        if (tagents_productid <= 0 || tagents_productSet.isEmpty()) {
            tagents_product = tagents_productSet.addAtEnd();
            tagents_product.setValue("siteid", siteid, 11L);//ҵID
            tagents_product.setValue("tagentsid", tagentsid, 11L);//ҵID
            tagents_product.setValue("createby", username, 11L);//¼
            tagents_product.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tagents_product = tagents_productSet.getPao(0);
        }
        tagents_product.setValue("fprodnum", fprodnum, 11L);//Ʒ
        tagents_product.setValue("fprodname", fprodname, 11L);//Ʒ
        tagents_product.setValue("fprice", fprice, 11L);//۵
        tagents_product.setValue("fprodclassname", fprodclassname, 11L);//ӪĿ
        tagents_product.setValue("fintroduction", fintroduction, 11L);//Ʒ
        //tagents_product.setValue("ftag", ftag, 11L);//Ʒǩ
        tagents_product.setValue("fnotes", fnotes, 11L);//ע
        tagents_product.setValue("changeby", username, 11L);//޸
        tagents_product.setValue("changedate", sysdate, 11L);//޸ʱ

        if (tagents_product.getBoolean("fisonsale") && !fisonsale) {
            tagents_product.setValue("foffsaleby", username, 11L);
            tagents_product.setValue("foffsaledate", sysdate, 11L);
        } else if (!tagents_product.getBoolean("fisonsale") && fisonsale) {
            tagents_product.setValue("fonsaleby", username, 11L);
            tagents_product.setValue("fonsaledate", sysdate, 11L);
        }
        tagents_product.setValue("fisonsale", fisonsale, 11L);
        content.put("tagents_productid", tagents_product.getUniqueIDValue());
        tagents_productSet.save();
        return query_productsMain();
    }

    /**
     * Ʒ¼
     *
     * @return
     */
    public String updatesalestatus() throws D3bException, P2Exception {
        ArrayList<String> sqlist = new ArrayList<>();
        JSONArray productlistArray = content.getJSONArray("productlist");
        for (Object o : productlistArray) {
            JSONObject product = (JSONObject) o;
            String tagents_productid = product.getString("tagents_productid");
            boolean fisonsale = product.getBoolean("fisonsale");
            SQLFactory sqlFactory = null;
            if (fisonsale) {
                sqlFactory = new SQLFactory(this, "Ʒϼ");
            } else {
                sqlFactory = new SQLFactory(this, "Ʒ¼");
            }
            sqlFactory.addParameter("username", username);
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tagentsid", tagentsid);
            sqlFactory.addParameter("tagents_productid", tagents_productid);
            sqlist.add(sqlFactory.getSQL());
        }
        String status = dbConnect.runSqlUpdate(sqlist);
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * Ʒɾ
     *
     * @return
     */
    public String deleteProducts() throws D3bException, P2Exception {
        long tagents_productid = content.getLongValue("tagents_productid");//ƷID
        Rows rows = dbConnect.runSqlQuery("select *from tagents_product where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tagents_productid='" + tagents_productid + "'");
        if (!rows.isEmpty() && rows.get(0).getBoolean("fisonsale")) {
            return getErrReturnObject().setErrMsg("ϼƷɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Ʒɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tagents_productid", tagents_productid);

        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ̻Ʒбѯ
     *
     * @return
     */
    public String query_cooperationProductsList() {
        SQLFactory sql = new SQLFactory(this, "̻Ʒбѯ", pageSize, pageNumber, "createdate");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap rowsMap = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", rowsMap.get(row.getString("tagents_productid")));
        }
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }
}
