package com.cnd3b.restcontroller.enterprise.products;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class products extends Controller {

    /**
     * 캯
     *
     * @param content
     */
    public products(JSONObject content) {
        super(content);
    }

    /**
     * Ʒбѯ
     *
     * @return
     */
    public String query_productsList() {
        long tagentsid = content.getLong("tagentsid");
        /**
         *
         */
        String[] sortfield = {"t1.fprodname"};
        String sort = getSort(sortfield, "t1.fprodname");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fprodname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fprodnum like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fintroduction like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftag like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fisonsale") && !"".equals(whereObject.getString("fisonsale"))) {
                if (whereObject.getBooleanValue("fisonsale")) {
                    where.append(" and t1.fisonsale=1 ");
                } else {
                    where.append(" and t1.fisonsale=0 ");
                }
            }
            if (whereObject.containsKey("notin") && !"".equals(whereObject.getString("notin"))) {
                JSONObject notinObject = whereObject.getJSONObject("notin");
                if (notinObject.containsKey("tactivity_agentproducts")) {
                    JSONObject tactivity_agentproductsObject = notinObject.getJSONObject("tactivity_agentproducts");
                    long tactivityid = tactivity_agentproductsObject.getLong("tactivityid");
                    where.append(" and not exists( select * from tactivity_agentproducts where siteid='" + siteid + "' " +
                            "and tactivityid='" + tactivityid + "' and tagentsid='" + tagentsid + "' and tagents_productid=t1.tagents_productid) ");
                }
            }
        }
        SQLFactory sql = new SQLFactory(this, "Ʒбѯ", pageSize, pageNumber, sort);
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", tagentsid);
        sql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap tagents_productMap = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", tagents_productMap.get(row.getString("tagents_productid")));
            row.put("ftag", JSONArray.parseArray(row.getString("ftag")));
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).saveToDataPool().toString();
    }

    /**
     * Ʒѯ
     *
     * @return
     */
    public String query_productsMain() {
        long tagentsid = content.getLong("tagentsid");
        SQLFactory sql = new SQLFactory(this, "Ʒѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", tagentsid);
        sql.addParameter("tagents_productid", content.getLong("tagents_productid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap tagents_productMap = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", tagents_productMap.get(row.getString("tagents_productid")));
            row.put("ftag", JSONArray.parseArray(row.getString("ftag")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ʒע
     *
     * @return
     * @throws P2Exception
     */
    public String addHotProducts() throws P2Exception {

        String fname = content.getString("fname");
        String ftype = content.getString("ftype");
        String frownum = content.getString("frownum");

        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("texcellenproducts");

        PaoRemote paoRemote = paoSetRemote.addAtEnd();
        paoRemote.setValue("texcellenproductid", paoRemote.getUniqueIDValue(), 11L);
        paoRemote.setValue("fname", fname);
        paoRemote.setValue("ftype", ftype);
        paoRemote.setValue("frownum", frownum);
        paoRemote.setValue("siteid", siteid);
        paoSetRemote.save();
        JSONObject resultObject = new JSONObject();
        resultObject.put("texcellenproductid", paoRemote.getUniqueIDValue());
        return getSucReturnObject().setData(resultObject).toString();


    }

    /**
     * ɾƷע
     *
     * @return
     */
    public String deleteHotProducts() {
        String texcellenproductsid = content.getString("texcellenproductsid");

        String sql = "DELETE FROM texcellenproducts WHERE texcellenproductid = '" + texcellenproductsid + "'";

        String response = dbConnect.runSqlUpdate(sql);
        if (response.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().toString();
        }

    }

    /**
     * Ʒע
     * @return
     * @throws P2Exception
     */
    public String updateHotProducts() throws P2Exception {
        String texcellenproductid = content.getString("texcellenproductid");
        String fname = content.getString("fname");
        String ftype = content.getString("ftype");
        String frownum = content.getString("frownum");

        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("texcellenproducts", " texcellenproductid = '" + texcellenproductid + "'");
        if (!paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.getPao(0);
            paoRemote.setValue("fname", fname);
            paoRemote.setValue("ftype", ftype);
            paoRemote.setValue("siteid", siteid);
            paoRemote.setValue("frownum", frownum);
            paoSetRemote.save();
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg("δҵӦ").toString();
        }

    }


    /**
     * ȡƷбע
     *
     * @return
     */
    public String getHotProductsList() {
        String ftype = content.getString("ftype");
        if (ftype == null) {
            ftype = "";
        }
        SQLFactory prodlistSql = new SQLFactory(this, "Ʒб", pageSize, pageNumber, "t1.ftype,t1.frownum");
        prodlistSql.addParameter("siteid", siteid);
        prodlistSql.addParameter("ftype", "%" + ftype + "%");
        Rows rows = prodlistSql.runSqlQuery();
        for (Row row : rows) {
            row.put("attinfos", getAttachmentUrl("texcellenproducts", row.getString("texcellenproductid")));
        }
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool(10).toString();

    }

}
