package com.cnd3b.restcontroller.publicmethod.users;

import com.cnd3b.utility.Encryption;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.common.restful.WebClientRest;
import com.cnd3b.utility.Sms;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Calendar;
import java.util.Random;

public class Users extends Controller {
    public Users(JSONObject content) {
        super(content);
    }

    /**
     * ½ʱûעԶע
     *
     * @return
     */
    public void register_usersByLogin(String fphonenumber, String siteid) {
        PaoSetRemote tagentsSet = null;
        try {
            tagentsSet = getP2ServerSystemPaoSet("tagents");
            PaoRemote tagents = tagentsSet.addAtEnd();
            tagents.setValue("siteid", siteid, 11L);//ҵID
            tagents.setValue("createdate", getDateTime(), 11L);//¼ʱ
            tagents.setValue("fphonenumber", fphonenumber, 11L);
            tagents.setValue("fjoindate", getDateTime(), 11L);
            tagents.setValue("ftype", "", 11L);
            tagentsSet.save();
            createSystemMessageByAgentsid("", "עỶӭ֪ͨ", "ϲעɹ", tagents.getUniqueIDValue());
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (tagentsSet != null) {
                    tagentsSet.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * ˺ע
     *
     * @return
     */
    public String register_users() throws D3bException, P2Exception {
        String fpassword = content.getString("fpassword");//֤
        String fphonenumber = content.getString("fphonenumber", "tagents.fphonenumber", "ֻ");//ֻ

        int resultcode;
        if (!parameter.register_passwordmap.containsKey(fphonenumber)) {
            resultcode = 1;//ûлȡ֤
        } else if (parameter.registerpassword_date.get(fphonenumber).before(Calendar.getInstance().getTime())) {
            resultcode = 2;//֤ʧЧ
        } else {
            //ϵͳ֤
            String syspassword = parameter.register_passwordmap.get(fphonenumber);
            if (fpassword.equals(new Encryption().Encode_MD5(syspassword))) {
                resultcode = 0;//֤ȷ
            } else {
                resultcode = 3;//֤
            }
        }
        if (resultcode == 0) {
            PaoSetRemote tagentsSet = getP2ServerSystemPaoSet("tagents");
            PaoRemote tagents = tagentsSet.addAtEnd();
            tagents.setValue("siteid", siteid, 11L);//ҵID
            tagents.setValue("createdate", getDateTime(), 11L);//¼ʱ
            tagents.setValue("fphonenumber", fphonenumber, 11L);
            tagents.setValue("fjoindate", getDateTime(), 11L);
            tagents.setValue("ftype", "", 11L);
            tagentsSet.save();
            createSystemMessageByAgentsid("", "עỶӭ֪ͨ", "ϲעɹ", tagents.getUniqueIDValue());

            WebClientRest rest = new WebClientRest();
            String password = rest.createPassWord();
            parameter.phonenumber_password.put(fphonenumber, password);
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.MINUTE, 30000000);
            parameter.phonenumber_date.put(fphonenumber, calendar.getTime());

            JSONObject object = new JSONObject();
            object.put("phonenumber", fphonenumber);
            object.put("password", new Encryption().Encode_MD5(password));

            parameter.register_passwordmap.remove(fphonenumber);
            parameter.registerpassword_date.remove(fphonenumber);
            return rest.login(object.toJSONString());
        } else {
            String msg = "";
            if (resultcode == 1) {
                msg = "Ȼȡ֤룡";
            } else if (resultcode == 2) {
                msg = "֤ʧЧ»ȡ";
            } else if (resultcode == 3) {
                msg = "Ч֤룡";
            }
            return getErrReturnObject().setErrMsg(msg).toString();
        }
    }

    /**
     * ע֤ȡ
     *
     * @return
     */
    public String getPassword() throws D3bException, P2Exception {
        String fphonenumber = content.getString("fphonenumber");//עֻ
        PaoSetRemote tagentsSet = getP2ServerSystemPaoSet("tagents", "fphonenumber='" + fphonenumber + "' and siteid='" + siteid + "'");
        if (!tagentsSet.isEmpty()) {
            return getErrReturnObject().setErrMsg("ֻעᣡ").toString();
        }
        String password = createPassWord();
        parameter.register_passwordmap.put(fphonenumber, password);
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.MINUTE, 5);
        parameter.registerpassword_date.put(fphonenumber, calendar.getTime());
        if (parameter.isdebug()) {
            return getSucReturnObject().setData("֤룺" + password).toString();
        } else {
            Sms sms = new Sms();
            sms.sendOutMsg(fphonenumber, password);
            return getSucReturnObject().setData("֤ѷͣעգ").toString();
        }
    }

    private String createPassWord() {
        String allChar = "1234567890";
        StringBuffer sb = new StringBuffer();
        Random random = new Random();
        for (int i = 0; i < 6; i++) {
            sb.append(allChar.charAt(random.nextInt(allChar.length())));
        }
        if (parameter.register_passwordmap.containsValue(sb.toString())) {
            return createPassWord();
        } else {
            return sb.toString();
        }
    }

    /**
     * ŶӼ
     *
     * @return
     */
    public String entryTeamApply() throws P2Exception {
        long userid = content.getLongValue("userid");
        long tagentsid = content.getLong("tagentsid");
        boolean fissaveagentmsg = content.getBooleanValue("fissaveagentmsg");//Ƿǰ̻Ϣ
        String fname = "";
        String fphonenumber = "";
        PaoSetRemote queryPaoSetRemote = getP2ServerSystemPaoSet("tagentteamapply", "tagentsid = '" + tagentsid + "' AND fuserid = '" + userid + "'");

        if (!queryPaoSetRemote.isEmpty()) {
            PaoRemote remote = queryPaoSetRemote.getPao(0);
            String fstatus = remote.getString("fstatus");
            if (fstatus.equals("")) {
                return getErrReturnObject().setErrCode(2).setErrMsg("").toString();
            } else if (fstatus.equals("")) {
                return getErrReturnObject().setErrCode(3).setErrMsg("ͨ").toString();
            }
        }

        if (userid > 0) {
            PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tenterprise_users", "tenterprise_userid = '" + userid + "'");
            if (!paoSetRemote.isEmpty()) {
                PaoRemote paoRemote = paoSetRemote.getPao(0);
                fname = paoRemote.getString("fname");
                fphonenumber = paoRemote.getString("fphonenumber");
            }

        } else {
            return getErrReturnObject().setErrMsg("δҵӦû").toString();

        }
        PaoRemote paoRemote = queryPaoSetRemote.addAtEnd();
        paoRemote.setValue("SITEID", siteid, 11L);
        paoRemote.setValue("FPHONENUMBER", fphonenumber, 11L);
        paoRemote.setValue("TENTERPRISE_USERID", userid, 11L);
        paoRemote.setValue("TAGENTSID", tagentsid, 11L);
        paoRemote.setValue("FNAME", fname, 11L);
        paoRemote.setValue("FSTATUS", "", 11L);
        paoRemote.setValue("FUSERID", userid, 11L);
        paoRemote.setValue("fissaveagentmsg", fissaveagentmsg, 11L);
        queryPaoSetRemote.save();

        return getSucReturnObject().setData("ɹ").toString();
    }
}
