package com.cnd3b.restcontroller.system.system;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.utility.Math;
import com.cnd3b.utility.obs.Bucket;
import com.cnd3b.utility.obs.BucketFile;
import com.cnd3b.utility.obs.mpc.MediaMetaData;
import com.cnd3b.utility.obs.mpc.MpcFactory;
import com.obs.services.model.HttpMethodEnum;
import org.apache.commons.lang.StringUtils;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;
import p2.webclient.system.controller.Utility;

import java.io.File;
import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.*;


public class docManage extends Controller {


    /**
     * ļиĿ¼
     */
    public static String gen_file = "/Users/shenjingwei/Documents/뿪/idea/DSB_CRM/p2-4.1.0_201907241548/deploy/build/pic.war/";

    public docManage(JSONObject content) {
        super(content);
    }

    public static HashMap<String, HashMap<String, String>> obsfilemap = new HashMap<>();

    /**
     * ȡļ
     *
     * @return
     */
    public String getFileName() {
        Bucket bucket = new Bucket(siteid);
        double fusevolume = bucket.getVolume();
        double fmaxvolume = 0;
        Rows rows = dbConnect.runSqlQuery("select fmaxvolume from tobsmag where siteid='" + siteid + "'");
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("ƴ洢ռ䲻").toString();
        }
        fmaxvolume = rows.get(0).getInteger("fmaxvolume");
        if (Math.mul(fmaxvolume, 1024d * 1024d * 1024d) <= fusevolume) {
            return getErrReturnObject().setErrMsg("ƴ洢ռ䲻").toString();
        }
        JSONObject object = new JSONObject();
        try {
            String filename = content.getString("filename");
            String filetype = content.getString("filetype");
            String ownertable = content.getString("ownertable");
            String ownerid = content.getString("ownerid");
            String ftype = content.getString("ftype");
            HttpMethodEnum HttpMethod = HttpMethodEnum.PUT;
            if (content.containsKey("HttpMethod")) {
                if ("post".equalsIgnoreCase(content.getString("HttpMethod"))) {
                    HttpMethod = HttpMethodEnum.POST;
                } else if ("get".equalsIgnoreCase(content.getString("HttpMethod"))) {
                    HttpMethod = HttpMethodEnum.GET;
                }
            }
            String serialnumber = createMD5FileName(filename) + "." + filetype;
            BucketFile bucketFile = new BucketFile(siteid);
            String url = bucketFile.getUploadUrl(filetype, serialnumber, HttpMethod);
            bucketFile.close();

            object.put("obsfilename", serialnumber);
            object.put("obsuploadurl", url);

            HashMap<String, String> map = new HashMap<>();
            map.put("filename", filename);
            map.put("filetype", filetype);
            map.put("ownertable", ownertable);
            map.put("ownerid", ownerid);
            map.put("ftype", ftype);

            obsfilemap.put(serialnumber, map);
        } catch (Exception e) {
            return getErrReturnObject().setErrMsg(e.getMessage()).toString();
        }
        return getSucReturnObject().setData(object).toString();
    }

    /**
     * ȡļ
     *
     * @return
     */
    public String getFileNames() {
        Bucket bucket = new Bucket(siteid);
        double fusevolume = bucket.getVolume();
        double fmaxvolume = 0;
        Rows rows = dbConnect.runSqlQuery("select fmaxvolume from tobsmag where siteid='" + siteid + "'");
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("ƴ洢ռ䲻").toString();
        }
        fmaxvolume = rows.get(0).getInteger("fmaxvolume");
        if (Math.mul(fmaxvolume, 1024d * 1024d * 1024d) <= fusevolume) {
            return getErrReturnObject().setErrMsg("ƴ洢ռ䲻").toString();
        }
        JSONArray returnarray = new JSONArray();

        JSONArray filesArray = content.getJSONArray("files");
        for (int i = 0; i < filesArray.size(); i++) {
            try {
                JSONObject fileobject = filesArray.getJSONObject(i);
                String filename = fileobject.getString("filename");
                String filetype = fileobject.getString("filetype");
                String ownertable = fileobject.getString("ownertable");
                String ownerid = fileobject.getString("ownerid");
                String ftype = fileobject.getString("ftype");
                HttpMethodEnum HttpMethod = HttpMethodEnum.PUT;
                if (content.containsKey("HttpMethod")) {
                    if ("post".equalsIgnoreCase(content.getString("HttpMethod"))) {
                        HttpMethod = HttpMethodEnum.POST;
                    } else if ("get".equalsIgnoreCase(content.getString("HttpMethod"))) {
                        HttpMethod = HttpMethodEnum.GET;
                    }
                }

                String serialnumber = createMD5FileName(filename) + "." + filetype;
                BucketFile bucketFile = new BucketFile(siteid);
                String url = bucketFile.getUploadUrl(filetype, serialnumber, HttpMethod);
                bucketFile.close();
                JSONObject object = new JSONObject();
                object.put("obsfilename", serialnumber);
                object.put("obsuploadurl", url);
                object.put("filename", filename);
                object.put("filetype", filetype);
                object.put("ftype", ftype);

                returnarray.add(object);

                HashMap<String, String> map = new HashMap<>();
                map.put("filename", filename);
                map.put("filetype", filetype);
                map.put("ownertable", ownertable);
                map.put("ownerid", ownerid);
                map.put("ftype", ftype);

                obsfilemap.put(serialnumber, map);
            } catch (Exception e) {
                return getErrReturnObject().setErrMsg(e.getMessage()).toString();
            }
        }
        return getSucReturnObject().setData(returnarray).toString();
    }

    /**
     * ޸ĸϢ
     *
     * @return
     */
    public String changeFilesData() {
        JSONArray files = content.getJSONArray("files");
        ArrayList<String> sqllist = new ArrayList<String>();
        for (Object o : files) {
            JSONObject file = (JSONObject) o;
            long tattachmentid = file.getLong("tattachmentid");
            String fdocument = file.getString("fdocument");
            String ownertable = file.getString("ownertable");
            long ownerid = file.getLong("ownerid");

            SQLFactory sql = new SQLFactory(this, "Ϣ");
            sql.addParameter("siteid", siteid);
            sql.addParameter("tattachmentid", tattachmentid);
            sql.addParameter("fdocument", fdocument);
            sql.addParameter("ownertable", ownertable);
            sql.addParameter("ownerid", ownerid);
            sqllist.add(sql.getSQL());
        }
        String status = dbConnect.runSqlUpdate(sqllist);
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    public String createMpcTask() {
        String siteid = content.getString("siteid");
        JSONArray obsfilenameArray = content.getJSONArray("obsfilenames");
        Iterator it = obsfilenameArray.iterator();
        ArrayList<String> sqllist = new ArrayList<>();
        while (it.hasNext()) {
            String obsfilename = (String) it.next();
            try {
                String mpctaskid = "";
                BucketFile bucketFile = new BucketFile(siteid);
                if (bucketFile.doesObjectExist(obsfilename)) {
                    /**
                     * Ƶת
                     */
                    if (obsfilename.endsWith("mp4") || obsfilename.endsWith("MP4")) {
                        MpcFactory mpcFactory = new MpcFactory();
                        MediaMetaData data = mpcFactory.getMetaData(siteid, obsfilename);
                        if (data != null) {
                            long bitrate = data.getBitrate();
                            long size = data.getSize();
                            if (bitrate / 1024 > 5000 || size / (1024 * 1024) > 500) {
                                System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                                mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
                            }
                        }
                    } else if (obsfilename.endsWith("mov") || obsfilename.endsWith("MOV")) {
                        System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                        MpcFactory mpcFactory = new MpcFactory();
                        mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
                    }
                }
                if (!mpctaskid.equals("")) {
                    sqllist.add("update tattachment set mpctaskid='" + mpctaskid + "' where siteid='" + siteid + "' and serialnumber='" + obsfilename + "'");
                } else {
                    sqllist.add("update tattachment set description='ת' where siteid='" + siteid + "' and serialnumber='" + obsfilename + "'");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        String Status = dbConnect.runSqlUpdate(sqllist);
        if (Status.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(Status).toString();
        }
    }

    public String uploadSuccess() {
        String obsfilename = content.getString("obsfilename");
        if (!obsfilemap.containsKey(obsfilename)) {
            return getErrReturnObject().setErrMsg("ҲӦƴ洢ļ").toString();
        }
        String filename = obsfilemap.get(obsfilename).get("filename");
        String filetype = obsfilemap.get(obsfilename).get("filetype");
        String ownertable = obsfilemap.get(obsfilename).get("ownertable");
        String ownerid = obsfilemap.get(obsfilename).get("ownerid");
        String ftype = obsfilemap.get(obsfilename).get("ftype");

        filename = filename.replace("'", "");

        JSONObject resultObject = new JSONObject();
        try {

            BucketFile bucketFile = new BucketFile(siteid);
            if (!bucketFile.doesObjectExist(obsfilename)) {
                return getErrReturnObject().setErrMsg("ҲӦƴ洢ļ").toString();
            }

            /**
             * Ƶת
             */
            String mpctaskid = "null";
            if (obsfilename.endsWith("mp4") || obsfilename.endsWith("MP4")) {
                MpcFactory mpcFactory = new MpcFactory();
                MediaMetaData data = mpcFactory.getMetaData(siteid, obsfilename);
                if (data != null) {
                    long bitrate = data.getBitrate();
                    long size = data.getSize();
                    if (bitrate / 1024 > 5000 || size / (1024 * 1024) > 500) {
                        System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                        mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
                    }
                }
            } else if (obsfilename.endsWith("mov") || obsfilename.endsWith("MOV")) {
                System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                MpcFactory mpcFactory = new MpcFactory();
                mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
            }
            ArrayList<String> SQlist = new ArrayList<>();

            /**
             * Ϣ
             */
            long tattachmentid = createTableID("tattachment", "tattachmentid");
            {
                SQLFactory sqlFactory = new SQLFactory(this, "Ϣ");
                sqlFactory.addParameter("tattachmentid", tattachmentid);
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("ownertable", ownertable);
                sqlFactory.addParameter("ownerid", ownerid);
                sqlFactory.addParameter("createby", username);
                sqlFactory.addParameter("ftype", ftype);
                sqlFactory.addParameter("postfix", filetype);
                sqlFactory.addParameter("serialnumber", obsfilename);
                sqlFactory.addParameter("fdocument", filename);
                sqlFactory.addParameter("fobsurl", bucketFile.getFileUrl(obsfilename));
                sqlFactory.addParameter("mpctaskid", mpctaskid);
                sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata(obsfilename).getContentLength());

                SQlist.add(sqlFactory.getSQL());
            }
            if (isImage(filetype)) {
                {
                    //ͼϢ
                    SQLFactory sqlFactory = new SQLFactory(this, "ӸϢ");
                    sqlFactory.addParameter("fparentid", tattachmentid);
                    sqlFactory.addParameter("tattachmentid", createTableID("tattachment", "tattachmentid"));
                    sqlFactory.addParameter("siteid", siteid);
                    sqlFactory.addParameter("ownertable", ownertable);
                    sqlFactory.addParameter("ownerid", ownerid);
                    sqlFactory.addParameter("createby", username);
                    sqlFactory.addParameter("ftype", "thumbnail");
                    sqlFactory.addParameter("postfix", filetype);
                    sqlFactory.addParameter("serialnumber", "s_" + obsfilename);
                    sqlFactory.addParameter("fdocument", filename);
                    sqlFactory.addParameter("fobsurl", bucketFile.getMinImageUrl(obsfilename));
                    sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata("s_" + obsfilename).getContentLength());
                    SQlist.add(sqlFactory.getSQL());
                }
                {
                    /**
                     * ѹͼϢ
                     */
                    SQLFactory sqlFactory = new SQLFactory(this, "ӸϢ");
                    sqlFactory.addParameter("fparentid", tattachmentid);
                    sqlFactory.addParameter("tattachmentid", createTableID("tattachment", "tattachmentid"));
                    sqlFactory.addParameter("siteid", siteid);
                    sqlFactory.addParameter("ownertable", ownertable);
                    sqlFactory.addParameter("ownerid", ownerid);
                    sqlFactory.addParameter("createby", username);
                    sqlFactory.addParameter("ftype", "compressed");
                    sqlFactory.addParameter("postfix", filetype);
                    sqlFactory.addParameter("serialnumber", "c_" + obsfilename);
                    sqlFactory.addParameter("fdocument", filename);
                    sqlFactory.addParameter("fobsurl", bucketFile.getCompressImageUrl(obsfilename));
                    sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata("c_" + obsfilename).getContentLength());
                    SQlist.add(sqlFactory.getSQL());
                }
            }

            dbConnect.runSqlUpdate(SQlist);
            obsfilemap.remove(obsfilename);
            resultObject.put("code", 1);
            resultObject.put("msg", "ɹ");

            if (content.getBooleanValue("fisreturnallfile")) {
                resultObject.put("data", queryDocRows(ownertable, ownerid));
            } else {
                resultObject.put("data", queryDocRow(obsfilename));
            }
            bucketFile.close();
            if (ftype.equalsIgnoreCase("headportrait")) {
                headPicMap.remove(userid);//ͷ񻺴
            }

            /**
             * ԶɾָĸϢ
             */
            if (content.containsKey("deleteattachmentids")) {
                JSONArray deleteattachmentids = content.getJSONArray("deleteattachmentids");//ҪɾĸϢid
                for (Object o : deleteattachmentids) {
                    long id = (long) o;
                    content.put("ownertable", ownertable);
                    content.put("ownerid", ownerid);
                    content.put("tattachmentid", id);
                    deleteDoc();
                }
            }
        } catch (Exception exception) {
            resultObject.put("code", 0);
            resultObject.put("msg", exception.getMessage());
        }
        return resultObject.toString();
    }

    public String uploadSuccesses() {
        JSONArray obsfilenamesArray = content.getJSONArray("obsfilenames");

        Iterator it = obsfilenamesArray.iterator();

        String ownertable = "";
        String ownerid = "";

        ArrayList<String> SQLlist = new ArrayList<>();

        JSONObject resultObject = new JSONObject();
        while (it.hasNext()) {
            String obsfilename = (String) it.next();
            if (!obsfilemap.containsKey(obsfilename)) {
                continue;
            }
            String filename = obsfilemap.get(obsfilename).get("filename");
            String filetype = obsfilemap.get(obsfilename).get("filetype");
            ownertable = obsfilemap.get(obsfilename).get("ownertable");
            ownerid = obsfilemap.get(obsfilename).get("ownerid");
            String ftype = obsfilemap.get(obsfilename).get("ftype");

            filename = filename.replace("'", "");
            try {
                BucketFile bucketFile = new BucketFile(siteid);
                if (!bucketFile.doesObjectExist(obsfilename)) {
                    continue;
                }

                /**
                 * Ƶת
                 */
                String mpctaskid = "null";
                if (obsfilename.endsWith("mp4") || obsfilename.endsWith("MP4")) {
                    MpcFactory mpcFactory = new MpcFactory();
                    MediaMetaData data = mpcFactory.getMetaData(siteid, obsfilename);
                    if (data != null) {
                        long bitrate = data.getBitrate();
                        long size = data.getSize();
                        if (bitrate / 1024 > 5000 || size / (1024 * 1024) > 500) {
                            System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                            mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
                        }
                    }
                } else if (obsfilename.endsWith("mov") || obsfilename.endsWith("MOV")) {
                    System.err.println("ʼƵת룺" + siteid + "," + obsfilename);
                    MpcFactory mpcFactory = new MpcFactory();
                    mpctaskid = mpcFactory.createMpcTask(siteid, obsfilename);
                }
                /**
                 * Ϣ
                 */
                long tattachmentid = createTableID("tattachment", "tattachmentid");
                {
                    SQLFactory sqlFactory = new SQLFactory(this, "Ϣ");
                    sqlFactory.addParameter("tattachmentid", tattachmentid);
                    sqlFactory.addParameter("siteid", siteid);
                    sqlFactory.addParameter("ownertable", ownertable);
                    sqlFactory.addParameter("ownerid", ownerid);
                    sqlFactory.addParameter("createby", username);
                    sqlFactory.addParameter("ftype", ftype);
                    sqlFactory.addParameter("postfix", filetype);
                    sqlFactory.addParameter("serialnumber", obsfilename);
                    sqlFactory.addParameter("fdocument", filename);
                    sqlFactory.addParameter("fobsurl", bucketFile.getFileUrl(obsfilename));
                    sqlFactory.addParameter("mpctaskid", mpctaskid);
                    sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata(obsfilename).getContentLength());
                    SQLlist.add(sqlFactory.getSQL());
                }
                if (isImage(filetype)) {
                    {
                        //ͼϢ
                        SQLFactory sqlFactory = new SQLFactory(this, "ӸϢ");
                        sqlFactory.addParameter("fparentid", tattachmentid);
                        sqlFactory.addParameter("tattachmentid", createTableID("tattachment", "tattachmentid"));
                        sqlFactory.addParameter("siteid", siteid);
                        sqlFactory.addParameter("ownertable", ownertable);
                        sqlFactory.addParameter("ownerid", ownerid);
                        sqlFactory.addParameter("createby", username);
                        sqlFactory.addParameter("ftype", "thumbnail");
                        sqlFactory.addParameter("postfix", filetype);
                        sqlFactory.addParameter("serialnumber", "s_" + obsfilename);
                        sqlFactory.addParameter("fdocument", filename);
                        sqlFactory.addParameter("fobsurl", bucketFile.getMinImageUrl(obsfilename));
                        sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata("s_" + obsfilename).getContentLength());
                        SQLlist.add(sqlFactory.getSQL());
                    }
                    {
                        /**
                         * ѹͼϢ
                         */
                        SQLFactory sqlFactory = new SQLFactory(this, "ӸϢ");
                        sqlFactory.addParameter("fparentid", tattachmentid);
                        sqlFactory.addParameter("tattachmentid", createTableID("tattachment", "tattachmentid"));
                        sqlFactory.addParameter("siteid", siteid);
                        sqlFactory.addParameter("ownertable", ownertable);
                        sqlFactory.addParameter("ownerid", ownerid);
                        sqlFactory.addParameter("createby", username);
                        sqlFactory.addParameter("ftype", "compressed");
                        sqlFactory.addParameter("postfix", filetype);
                        sqlFactory.addParameter("serialnumber", "c_" + obsfilename);
                        sqlFactory.addParameter("fdocument", filename);
                        sqlFactory.addParameter("fobsurl", bucketFile.getCompressImageUrl(obsfilename));
                        sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata("c_" + obsfilename).getContentLength());
                        SQLlist.add(sqlFactory.getSQL());
                    }
                }

                obsfilemap.remove(obsfilename);
                bucketFile.close();
            } catch (Exception exception) {
                exception.printStackTrace();
            }
            if (ftype.equalsIgnoreCase("headportrait")) {
                headPicMap.remove(userid);//ͷ񻺴
            }
        }
        String fstatus = dbConnect.runSqlUpdate(SQLlist);
        if (fstatus.equals("true")) {
            int filecount = obsfilenamesArray.size();
            if (filecount == SQLlist.size()) {
                resultObject.put("code", 1);
                resultObject.put("msg", "ɹϴ" + filecount + "ļ");
            } else if (filecount > SQLlist.size() && SQLlist.size() > 0) {
                resultObject.put("code", 1);
                resultObject.put("msg", "ɹϴ" + SQLlist.size() + "ļ,ʧ" + (filecount - SQLlist.size() + ""));
            } else if (SQLlist.size() == 0) {
                resultObject.put("code", 0);
                resultObject.put("msg", "ϴʧ");
            }
        } else {
            resultObject.put("code", 0);
            resultObject.put("msg", "ϴʧ" + fstatus);
        }
        resultObject.put("data", queryDocRows(ownertable, ownerid));
        return resultObject.toString();
    }


    /**
     * ȡϴĳļ
     *
     * @return
     */
    public String getFileType(byte[] filebyte) {
        String ftype = null;
        try {
            StringBuilder builder = new StringBuilder();
            if (filebyte == null || filebyte.length <= 0) {
                return "";
            }
            String hv;
            for (byte value : filebyte) {
                // ʮƣ 16޷ʽһַʾʽתΪд
                hv = Integer.toHexString(value & 0xFF).toUpperCase();
                if (hv.length() < 2) {
                    builder.append(0);
                }
                builder.append(hv);
            }
            ftype = builder.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (StringUtils.startsWith(ftype, "FFD8FF")) {
            return "JPG";
        } else if (StringUtils.startsWith(ftype, "89504E47")) {
            return "PNG";
        } else if (StringUtils.startsWith(ftype, "47494638")) {
            return "GIF";
        } else if (StringUtils.startsWith(ftype, "424D")) {
            return "BMP";
        } else if (StringUtils.startsWith(ftype, "41433130")) {
            return "DWG";
        } else if (StringUtils.startsWith(ftype, "38425053")) {
            return "PSD";
        }
        return "";
    }

    public boolean isImage(String filetype) {
        if (filetype.equalsIgnoreCase("JPG")) {
            return true;
        }
        if (filetype.equalsIgnoreCase("JPEG")) {
            return true;
        }
        return filetype.equalsIgnoreCase("PNG");
    }


    public String deleteDoc() throws P2Exception {
        String ownertable = content.getString("ownertable");
        String ownerid = content.getString("ownerid");
        String tattachmentid = content.getString("tattachmentid");

        if (ownertable == null || ownertable.equals("")) {
            return getErrReturnObject().setErrMsg("ownertableΪ").toString();
        }
        if (ownerid == null || ownerid.equals("")) {
            return getErrReturnObject().setErrMsg("owneridΪ").toString();
        }
        if (tattachmentid == null || tattachmentid.equals("")) {
            return getErrReturnObject().setErrMsg("tattachmentidΪ").toString();
        }


        Rows rows = dbConnect.runSqlQuery("select serialnumber,tattachmentid from tattachment t1 where siteid='" + siteid + "' and tattachmentid=" + tattachmentid);
        if (!rows.isEmpty()) {
            String objectname = rows.get(0).getString("serialnumber");
            BucketFile bucketFile = new BucketFile(siteid);
            bucketFile.deleteFile(objectname);

            Rows subrows = dbConnect.runSqlQuery("select ftype,serialnumber from tattachment where fparentid=" + tattachmentid);
            for (Row subrow : subrows) {
                String ftype = subrow.getString("ftype");
                String serialnumber = subrow.getString("serialnumber");
                if ("hls".equals(ftype)) {
                    bucketFile.deleteFolder(serialnumber);
                } else {
                    bucketFile.deleteFile(serialnumber);
                }
            }
            bucketFile.close();
        }

        SQLFactory delete = new SQLFactory(this, "Ϣɾ");
        delete.addParameter("siteid", siteid);
        delete.addParameter("tattachmentid", tattachmentid);
        dbConnect.runSqlUpdate(delete.getSQL());

        returnObject.put("code", 1);
        returnObject.put("msg", "ɹ");
        returnObject.put("data", queryDocRows(ownertable, ownerid));

        return returnObject.toString();
    }

    public String queryDoc() {
        String ownertable = content.getString("ownertable");
        String ownerid = content.getString("ownerid");
        if (ownertable == null || ownertable.equals("")) {
            return getErrReturnObject().setErrMsg("ownertableΪ").toString();
        }
        if (ownerid == null || ownerid.equals("")) {
            return getErrReturnObject().setErrMsg("owneridΪ").toString();
        }
        Rows rows;
        if (content.containsKey("ftype") && !"".equals(content.getString("ftype"))) {
            rows = queryDocRows(ownertable, ownerid, content.getString("ftype"));
        } else {
            rows = queryDocRows(ownertable, ownerid);
        }
        if ("system".equalsIgnoreCase(ownertable)) {
            return getSucReturnObject().setData(rows).saveToDataPool(60 * 6).toString();
        } else {
            return getSucReturnObject().setData(rows).saveToDataPool().toString();
        }
    }

    private Rows queryDocRows(String ownertable, String ownerid) {
        return getAttachmentUrl(ownertable, ownerid);
    }

    private Rows queryDocRows(String ownertable, String ownerid, String ftype) {
        return getAttachmentUrl(ownertable, ownerid, ftype);
    }

    private Rows queryDocRow(String obsfilename) {
        return getAttachmentUrl(obsfilename);
    }


    /**
     * ȥļеĶַո񡢻зس
     *
     * @param filename
     * @return
     */
    private static String createFileName(String filename) {
        StringBuilder newfilename = null;
        StringTokenizer stringTokenizer = new StringTokenizer(filename.trim());
        while (stringTokenizer.hasMoreTokens()) {
            if (newfilename == null) {
                newfilename = new StringBuilder(stringTokenizer.nextToken());
            } else {
                newfilename.append(stringTokenizer.nextToken());
            }
        }
        return newfilename.toString();
    }

    /**
     * һΨһˮΪƴ洢ļ
     *
     * @param filename
     * @return
     * @throws IOException
     */
    private static String createMD5FileName(String filename) throws IOException {
        String date_str;
        String newfilename;
        do {
            Date date = new Date();
            date_str = (new SimpleDateFormat("yyyyMMdd")).format(date);
            long time = date.getTime();
            int random = java.lang.Math.abs((new Random()).nextInt() % 1000);
            String var3 = null;
            try {
                var3 = MessageDigest.getInstance("MD5").digest(String.valueOf(random).getBytes()).toString().replaceAll("[^a-z^A-Z^0-9]", "");
            } catch (NoSuchAlgorithmException e) {
                e.printStackTrace();
            }

            date_str = date_str + time + var3;
            newfilename = filename + File.separator + date_str;
        } while ((new File(newfilename)).exists());

        return date_str;
    }


    /**
     * У
     *
     * @param filename
     * @param ownertable
     * @param ownerid
     * @return
     */
    public JSONObject fileCheck(String filename, String ownertable, String ownerid) {
        JSONObject resultObject = new JSONObject();
        if (Utility.isNull(ownertable)) {
            resultObject.put("code", 0);
            resultObject.put("msg", "ownertable");
        } else if (Utility.isNull(ownerid)) {
            resultObject.put("code", 0);
            resultObject.put("msg", "ownerid");
        } else if (Utility.isNull(filename)) {
            resultObject.put("code", 0);
            resultObject.put("msg", "޷ȡļ");
        } else if (Utility.isNull(siteid)) {
            resultObject.put("code", 0);
            resultObject.put("msg", "siteid");
        }
        return resultObject;
    }

    /**
     * ־
     *
     * @return
     */
    public String createdownloadlog() {
        String tattachmentid = content.getString("tattachmentid");
        PaoSetRemote tattachment_downlogSet = null;
        try {
            tattachment_downlogSet = getP2ServerSystemPaoSet("tattachment_downlog");
            PaoRemote tattachment_downlog = tattachment_downlogSet.addAtEnd();
            tattachment_downlog.setValue("siteid", siteid, 11L);
            tattachment_downlog.setValue("createby", username, 11L);
            tattachment_downlog.setValue("createdate", getDateTime(), 11L);
            tattachment_downlog.setValue("tagentsid", tagentsid, 11L);
            tattachment_downlog.setValue("tattachmentid", tattachmentid, 11L);
            tattachment_downlog.setValue("tenterprise_userid", userid, 11L);
            tattachment_downlogSet.save();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                tattachment_downlogSet.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return getSucReturnObject().toString();
    }

}
