package com.cnd3b.restcontroller.system.users;

import com.cnd3b.common.data.Row;
import com.cnd3b.utility.Encryption;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.utility.Sms;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Calendar;
import java.util.Random;

public class Users extends Controller {
    /**
     * @param content
     */
    public Users(JSONObject content) {
        super(content);
    }

    public String getChangePhonenumberPassword() {
        String phonenumber = content.getString("newphonenumber");
        String password = createPassWord();
        parameter.changephonenumber_passwordmap.put(phonenumber, password);
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.MINUTE, 5);
        parameter.changephonenumber_date.put(phonenumber, calendar.getTime());

        if (parameter.isdebug()) {
            JSONObject object = new JSONObject();
            object.put("code", 1);
            object.put("msg", "֤룺" + password);
            return object.toString();
        } else {
            JSONObject object = new JSONObject();
            Sms sms = new Sms();
            sms.sendOutMsg(phonenumber, password);
            object.put("code", 1);
            object.put("msg", "֤ѷͣעգ");
            return object.toString();
        }
    }

    private String createPassWord() {
        String allChar = "1234567890";
        StringBuffer sb = new StringBuffer();
        Random random = new Random();
        for (int i = 0; i < 6; i++) {
            sb.append(allChar.charAt(random.nextInt(allChar.length())));
        }
        if (parameter.changephonenumber_passwordmap.containsValue(sb.toString())) {
            return createPassWord();
        } else {
            return sb.toString();
        }
    }

    /**
     * ޸ֻ
     *
     * @return
     */
    public String changePhonenumber() throws P2Exception {
        String password = content.getString("password");//ֻ֤
        String phonenumber = content.getString("newphonenumber");//ֻ

        int resultcode;
        if (!parameter.changephonenumber_passwordmap.containsKey(phonenumber)) {
            resultcode = 1;//ûлȡ֤
        } else if (parameter.changephonenumber_date.get(phonenumber).before(Calendar.getInstance().getTime())) {
            resultcode = 2;//֤ʧЧ
        } else {
            //ϵͳ֤
            String syspassword = parameter.changephonenumber_passwordmap.get(phonenumber);
            if (password.equals(new Encryption().Encode_MD5(syspassword))) {
                resultcode = 0;//֤ȷ
            } else {
                resultcode = 3;//֤
            }
        }
        if (resultcode == 0) {
            PaoSetRemote tenterprise_usersSet = getP2ServerSystemPaoSet("tenterprise_users", "tenterprise_userid='" + userid + "' and siteid='" + siteid + "'");
            if (!tenterprise_usersSet.isEmpty()) {
                tenterprise_usersSet.getPao(0).setValue("fphonenumber", phonenumber, 11L);
                tenterprise_usersSet.save();
            } else {
                return getErrReturnObject().setErrMsg("Ҳǰ˺Ϣ").toString();
            }
            parameter.changephonenumber_passwordmap.remove(phonenumber);
            parameter.changephonenumber_date.remove(phonenumber);
            return getSucReturnObject().toString();
        } else {
            String msg = "";
            if (resultcode == 1) {
                msg = "Ȼȡֻ֤룡";
            } else if (resultcode == 2) {
                msg = "֤ʧЧ»ȡ";
            } else if (resultcode == 3) {
                msg = "Ч֤룡";
            }
            JSONObject object = new JSONObject();
            object.put("code", 0);
            object.put("msg", msg);
            return object.toString();
        }
    }

    /**
     * ¼ûѯֻһ
     *
     * @return
     */
    public String getSubUserList() {
        SQLFactory sqlFactory = new SQLFactory(this, "¼˺Ųѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("fparentid", userid);
        Rows rows = getSubUserRows();
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ȡûϢ
     *
     * @return
     */
    public String getSimpleUserMsg() {
        long userid = content.getLong("userid");
        String headportraiturl = getHeadPic(userid);
        Row row = getUser(userid);
        if (row != null) {
            JSONObject object = new JSONObject();
            object.put("fname", row.getString("fname"));
            object.put("headportraiturl", headportraiturl);
            object.put("fsex", row.getString("fsex"));
            return getSucReturnObject().setData(object).saveToDataPool(100).toString();
        } else {
            return getErrReturnObject().setErrMsg("ڵûϢ").toString();
        }
    }
}
