package com.cnd3b.utility.obs;

import com.cnd3b.common.parameter.parameter;
import com.obs.services.ObsClient;
import com.obs.services.exception.ObsException;
import com.obs.services.model.*;

import java.util.ArrayList;
import java.util.List;

public class BucketTest {
    protected String bucketname;
    ObsClient obsClient;

    public BucketTest(String siteid) {
        // ObsClientʵ
        obsClient = new ObsClient("4RMST7WMRECXTYVMFVZQ", "YbxBUDT2UeohsWi7dyZ8MCUKOTodjrqNwnZ0VjEL", "obs.cn-east-2.myhuaweicloud.com");
        this.bucketname = siteid.toLowerCase();
        //a();
    }

    public void setBucketCors() {
        BucketCors cors = new BucketCors();

        List<BucketCorsRule> rules = new ArrayList<BucketCorsRule>();
        BucketCorsRule rule = new BucketCorsRule();

        ArrayList<String> allowedOrigin = new ArrayList<String>();
// ָԴ
        allowedOrigin.add("*");
        rule.setAllowedOrigin(allowedOrigin);

        ArrayList<String> allowedMethod = new ArrayList<String>();
// ָĿ󷽷(GET/PUT/DELETE/POST/HEAD)
        allowedMethod.add("GET");
        allowedMethod.add("HEAD");
        allowedMethod.add("PUT");
        allowedMethod.add("POST");
        allowedMethod.add("DELETE");
        rule.setAllowedMethod(allowedMethod);

        ArrayList<String> allowedHeader = new ArrayList<String>();
// OPTIONSԤȡָAccess-Control-Request-HeadersͷָheaderǷʹ
        allowedHeader.add("*");
        rule.setAllowedHeader(allowedHeader);

        //ArrayList<String> exposeHeader = new ArrayList<String>();
// ָûӦóзʵheader
//        exposeHeader.add("x-obs-expose-header");
//        rule.setExposeHeader(exposeHeader);

// ָضԴԤȡ(OPTIONS)󷵻ؽĻʱ,λΪ
        rule.setMaxAgeSecond(3600);
        rules.add(rule);
        cors.setRules(rules);
        obsClient.setBucketCors(bucketname, cors);
    }

    public String getBucketName() {
        return this.bucketname;
    }


    /**
     * Ͱ
     */
    public boolean create() {
        // Ͱ
        try {
            ObsBucket obsBucket = new ObsBucket();
            obsBucket.setBucketName(bucketname);
            // ͰȨΪд
            obsBucket.setAcl(AccessControlList.REST_CANNED_PUBLIC_READ_WRITE);
            // Ͱλ
            obsBucket.setLocation(parameter.Bucket_location());
            // Ͱ
            HeaderResponse response = obsClient.createBucket(obsBucket);
            setBucketCors();
        } catch (ObsException e) {
            // Ͱʧ
            System.out.println("HTTP Code: " + e.getResponseCode());
            System.out.println("Error Code:" + e.getErrorCode());
            System.out.println("Error Message: " + e.getErrorMessage());

            System.out.println("Request ID:" + e.getErrorRequestId());
            System.out.println("Host ID:" + e.getErrorHostId());
            return false;
        }
        return true;
    }

    /**
     * ǷѴͰ
     *
     * @return
     */
    public boolean isAllReadyUsed() {
        return obsClient.headBucket(bucketname);
    }


    /**
     * ɾͰ
     *
     * @return
     */
    public void delete() {
        // ɾͰ
        obsClient.deleteBucket(bucketname);
    }

    /**
     * Ͱ,λG
     */
    public void setVolume(long volume) {
        BucketQuota quota = new BucketQuota(1024 * 1024 * 1024 * volume);
        obsClient.setBucketQuota(bucketname, quota);
    }

    /**
     * ȡͰ,λֽ
     */
    public long getMaxVolume() {
        BucketQuota quota = obsClient.getBucketQuota(bucketname);
        return quota.getBucketQuota();
    }

    /**
     * ȡͰ
     *
     * @return
     */
    public long getVolume() {
        BucketStorageInfo storageInfo = obsClient.getBucketStorageInfo(bucketname);
        return storageInfo.getSize();
    }

    /**
     * ȡļ
     *
     * @return
     */
    public long getFileCount() {
        BucketStorageInfo storageInfo = obsClient.getBucketStorageInfo(bucketname);
        return storageInfo.getObjectNumber();
    }

    public void getFiles() {
        ListObjectsRequest request = new ListObjectsRequest(bucketname);
        // ļж"dir/"Ϊǰ׺
        //request.setPrefix("dir/");
        request.setMaxKeys(1000);
        ObjectListing result;
        int i = 0;
        do {
            result = obsClient.listObjects(request);
            for (ObsObject obsObject : result.getObjects()) {
                System.out.println(++i + ":" + obsObject.getObjectKey());
                //System.out.println("\t" + obsObject.getOwner());
            }
            request.setMarker(result.getNextMarker());
        } while (result.isTruncated());
    }

    public static void main(String[] args) {
        BucketTest bucket = new BucketTest("bwj");
        bucket.getFiles();
    }
}
