package com.cnd3b.utility.obs.mpc;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.parameter.parameter;
import com.google.gson.Gson;
import com.huawei.mpc.client.MpcClient;
import com.huawei.mpc.client.MpcConfig;
import com.huawei.mpc.model.ObsObjInfo;
import com.huawei.mpc.model.extract.CreateExtractTaskReq;
import com.huawei.mpc.model.extract.CreateExtractTaskRsp;
import com.huawei.mpc.model.transcoding.*;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class MpcFactory {
    MpcConfig mpcConfig = null;

    public MpcFactory() {
        mpcConfig = new MpcConfig();

        mpcConfig.setEndPoint(parameter.Bucket_endPoint());// תڵַ
        mpcConfig.setProjectId("0770870e5900265f2f60c00b589e3ff6");// ûĿProjectId
        //mpcConfig.setSk(parameter.Bucket_sk());// sk
        //mpcConfig.setAk(parameter.Bucket_ak());// ak
        mpcConfig.setSk(parameter.Bucket_sk());// sk
        mpcConfig.setAk(parameter.Bucket_ak());// ak
    }


    public String createMpcTask(String bucketname, String filename) {
        bucketname = bucketname.toLowerCase();
        // ý崦췽
        MpcClient mpcClient = new MpcClient(mpcConfig);
        //ý崦
        CreateTranscodingRequest createTranscodingRequest = new CreateTranscodingRequest();

        //תԴļַ
        ObsObjInfo input = new ObsObjInfo();
        input.setBucket(bucketname);
        input.setObject(filename);
        input.setLocation("cn-east-2");
        createTranscodingRequest.setInput(input);


        // תļŵַ
        ObsObjInfo output = new ObsObjInfo();
        output.setBucket(bucketname);
        output.setObject(filename + "-hls");
        output.setLocation("cn-east-2");
        createTranscodingRequest.setOutput(output);

        /*
        // ѡˮӡܣҪˮӡʱŽã
        CreateTranscodingRequest.Watermark watermark = new CreateTranscodingRequest.Watermark();
        watermark.setTemplateId("watermark_template_id");
        // ˮӡͼƬַ
        ObsObjInfo watermarkInput  = new ObsObjInfo();
        watermarkInput.setBucket("bucketName");
        watermarkInput.setObject("objectKey");
        watermarkInput.setLocation("cn-north-4");
        watermark.setInput(watermarkInput);


        List<CreateTranscodingRequest.Watermark> watermarks = new ArrayList<CreateTranscodingRequest.Watermark>();
        watermarks.add(watermark);

        CreateTranscodingRequest.Watermark[] watermarkArray = new CreateTranscodingRequest.Watermark[watermarks.size()];
        createTranscodingRequest.setWatermarks(watermarks.toArray(watermarkArray));
        */

        //תģID
        List<Long> transTempIds = new ArrayList<Long>();
        transTempIds.add(7000494L);
        createTranscodingRequest.setTransTemplateId(transTempIds);

        /*
         // ýͼҪͼʱŽã
         CreateTranscodingRequest.Thumbnail thumbnail = new CreateTranscodingRequest.Thumbnail();
         //ýͼļʽ˴Ϊtarʽ
         thumbnail.setTar(1);
         //ýͼԴļַ,ȷѶý崦ͰȨ
         ObsObjInfo thumbOutput = new ObsObjInfo();
         //OBSͰ
         thumbOutput.setBucket("obs-bills");
         //OBSͰ
         thumbOutput.setLocation("cn-north-4");
         //OBSͰ´·
         thumbOutput.setObject("output/thumbnail/");
         thumbnail.setThumbOutput(thumbOutput);
         CreateThumbnailRequest.ThumbnailPara thumbnailPara = new CreateThumbnailRequest.ThumbnailPara();
         //ֲ֧͡ʽPERCENTTIMEDOTS(ʱtimeƵʱٷֱpercentʱͼʱʱdotsĿǰֻ֧TIMEDOTSַʽ)
         thumbnailPara.setTime(12);
         //󳤶
         thumbnailPara.setMaxLength(480);
         //ݺ
         thumbnailPara.setAspectRatio(0);
         //ýͼʽ0ʾĬϣ1ʾJPGʽ
         thumbnailPara.setFormat(1);
         createTranscodingRequest.setThumbnail(thumbnail);
         */

        /*
       //תȼ 6ȼĬΪǰȼ9ȼ
        createTranscodingRequest.setPriority(6);
        */

       /*
       //Ļ
       CreateTranscodingRequest.Subtitle subtitle = new CreateTranscodingRequest.Subtitle();
       //Ļ 0Ļ 1ⲿĻļǶƵ
       subtitle.setSubtitleType(1);
       //Ļļַ
       ObsObjInfo fileInput = new ObsObjInfo();
       fileInput.setBucket("bucketName");
       fileInput.setObject("objectKey");
       fileInput.setLocation("cn-north-4");
       subtitle.setSubtitleFile(fileInput);
       createTranscodingRequest.setSubtitle(subtitle);
       */
/*
        // üܲ
        CreateTranscodingRequest.Encryption encryption = new CreateTranscodingRequest.Encryption();
        CreateTranscodingRequest.Encryption.Multidrm multidrm = new CreateTranscodingRequest.Encryption.Multidrm();
        //content_idΨһʶ
        multidrm.setContentId("contentId");
        //ͣȡֵΪDASHHLS
        multidrm.setStreamingMode("HLS");
        //Ƶܿأ0ʶƵܣ1ʶƵܣĬ0
        multidrm.setEncryptAudio(1);
        //ܷʽȡֵĬΪ16420
        multidrm.setEmi(16420);
        multidrm.setDrmList(new String[]{"PLAYREADY"});
        encryption.setMultidrm(multidrm);
        createTranscodingRequest.setEncryption(encryption);
*/
        /*
        // ͼת
        VideoProcess videoProcess = new VideoProcess();
        // Ƶ˳ʱתǶȣȡֵΪ0,1,2,30ʾת1ʾ˳ʱת90ȣ2ʾ˳ʱת180ȣ3ʾ˳ʱת270.
        videoProcess.setRotate(2);
        createTranscodingRequest.setVideoProcess(videoProcess);
*/
        // ûǿ
        QualityEnhance qualityEnhance = new QualityEnhance();
        // һͨƬԴͨǿ񻯵ȼЧôǰ󣬷ֱʡ֡ʵȲ仯
        qualityEnhance.setNormalEnhance(QualityEnhance.NormalEnhanceEnum.NORMAL);
        createTranscodingRequest.setQualityEnhance(qualityEnhance);

        // ڲ
        AudioProcess audioProcess = new AudioProcess();
        // ʽȡֵΪautodynamicautoʾԶdynamicʾΪ趨ֵ
        audioProcess.setVolume(AudioProcess.VolumeEnum.DYNAMIC);
        // ֵΧ[-15,15],λdB ָvolumeΪdynamic
        audioProcess.setVolumeExpr(15);
        createTranscodingRequest.setAudioProcess(audioProcess);

        //ý崦
        CreateTranscodingResponse createTranscodingResponse = mpcClient.createTranscodingTask(createTranscodingRequest);
        //Ϣ
        String taskId = "";
        JSONObject resultObject = (JSONObject) JSON.toJSON(createTranscodingResponse);
        if (resultObject.containsKey("requestStatus") && "SUCCESS".equalsIgnoreCase(resultObject.getString("requestStatus"))) {
            taskId = resultObject.getString("taskId");
        }
        return taskId;
    }

    public MpcFile queryMpcTask(String taskId) {
        //ý崦췽
        MpcClient mpcClient = new MpcClient(mpcConfig);

        //òѯת
        QueryTranscodingRequest queryTranscodingRequest = new QueryTranscodingRequest();

        //ѯת񣬶תIDһֻܲѯ10
        String[] taskIds = {taskId};
        //öѯתID
        queryTranscodingRequest.setTaskIdArray(taskIds);

        /**
         * According to the status query
         */
        /*String status="CANCELED";
        //ת״̬ѯת״̬
        queryTranscodingRequest.setStatus(status);*/

        /**
         * According to the page&size query,If you do not provide default display 10 data
         */
        //ҳÿҳѯ
        //ҳ
        /*queryTranscodingRequest.setPage(0);
        //ÿҳ
        queryTranscodingRequest.setSize(4);*/

        /**
         * According to the startTime&endTime query
         */
        //תʼͽʱѯ
        //תʼʱ
        /*queryTranscodingRequest.setStartTime("20180116125625");
        //תʱ
        queryTranscodingRequest.setEndTime("20180118132810");*/

        //Ͳѯת
        QueryTranscodingResponse queryTranscodingResponse = mpcClient.queryTranscodingTask(queryTranscodingRequest);

        /*response*/
        //زѯת
        JSONObject resultObject = JSON.parseObject(new Gson().toJson(queryTranscodingResponse));

        if (resultObject.containsKey("requestStatus") && "SUCCESS".equalsIgnoreCase(resultObject.getString("requestStatus"))) {
            if (resultObject.containsKey("task_array")) {
                JSONArray task_array = resultObject.getJSONArray("task_array");
                for (Object o : task_array) {
                    JSONObject object = (JSONObject) o;
                    if (taskId.equalsIgnoreCase(object.getString("task_id"))) {
                        MpcFile mpcFile = new MpcFile();
                        mpcFile.setTask_id(taskId);
                        if ((object.getJSONArray("output_file_name").isEmpty())) {
                            return null;
                        } else {
                            mpcFile.setOutput_file_name(object.getJSONArray("output_file_name").getString(0));
                        }
                        JSONObject outputObject = object.getJSONObject("output");
                        mpcFile.setBucket(outputObject.getString("bucket"));
                        mpcFile.setLocation(outputObject.getString("location"));
                        mpcFile.setObject(outputObject.getString("object"));
                        return mpcFile;
                    }
                }
            }
        }
        return null;
    }

//    public void deleteMpcTask(String taskId) {
//        MpcClient mpcClient = new MpcClient(mpcConfig);
//        BaseResponse baseResponse = mpcClient.deleteTranscodingTask(taskId);
//        JSONObject resultObject = (JSONObject) JSON.toJSON(baseResponse);
//    }

    public MediaMetaData getMetaData(String bucketname, String filename) {
        bucketname = bucketname.toLowerCase();
        MediaMetaData mediaMetaData = new MediaMetaData();
        MpcClient mpcClient = new MpcClient(mpcConfig);
        CreateExtractTaskReq req = new CreateExtractTaskReq();

        ObsObjInfo input = new ObsObjInfo();
        input.setBucket(bucketname);
        input.setLocation("cn-east-2");
        input.setObject(filename);
        req.setInput(input);
        try {
            // 
            CreateExtractTaskRsp rsp = mpcClient.createExtractTask(req);
            JSONObject resultObject = (JSONObject) JSON.toJSON(rsp);
            if ("SUCCESS".equalsIgnoreCase(resultObject.getString("requestStatus")) && "SUCCEED".equalsIgnoreCase(resultObject.getString("status"))) {
                JSONObject metadataObject = resultObject.getJSONObject("metadata");

                mediaMetaData.setSize(metadataObject.getLongValue("size"));
                mediaMetaData.setFormat(metadataObject.getString("format"));
                mediaMetaData.setStatus(true);

                if (metadataObject.containsKey("video")) {
                    JSONArray videoArray = metadataObject.getJSONArray("video");
                    Iterator it = videoArray.iterator();
                    while (it.hasNext()) {
                        JSONObject videoObjcet = (JSONObject) it.next();
                        mediaMetaData.setCodec(videoObjcet.getString("codec"));
                        mediaMetaData.setFrameRate(videoObjcet.getIntValue("frameRate"));
                        mediaMetaData.setWidth(videoObjcet.getIntValue("width"));
                        mediaMetaData.setHeight(videoObjcet.getIntValue("height"));
                        mediaMetaData.setBitrate(videoObjcet.getLongValue("bitrate"));
                    }
                }
            } else {
                mediaMetaData.setStatus(false);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mediaMetaData;
    }

    public static void main(String[] args) {
        MpcFactory mpcFactory = new MpcFactory();
        mpcFactory.getMetaData("jxyl", "202104231619140535806B4e81fa83.mp4");
    }
}
