package com.cnd3b.websocketcontroller.message;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.common.websocket.WebClientSocket;
import com.cnd3b.utility.Encryption;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Calendar;

public class message extends Controller {

    /**
     * 캯
     *
     * @param content
     */
    public message(JSONObject content) {
        super(content);
    }
    //String fmessagetype = content.getString("fmessagetype");//Ϣͣtext,file,data,image

    /**
     * Ϣ
     *
     * @return
     */
    public String sendTextMessage() throws P2Exception {
        long timdialogid = content.getLong("timdialogid");//ԻID
        String fmessage = content.getString("fmessage");//Ϣ

        JSONObject messageObject = new JSONObject();
        messageObject.put("timdialogid", timdialogid);
        messageObject.put("ftype", "text");
        messageObject.put("fdatetime", getDateTime_Str());
        messageObject.put("fmessageid", new Encryption().Encode_MD5(siteid + userid + Calendar.getInstance().getTimeInMillis()));

        /**
         * ͷϢ
         */
        JSONObject sendfromObject = new JSONObject();
        sendfromObject.put("userid", userid);
        sendfromObject.put("siteid", siteid);
        sendfromObject.put("username", username);
        sendfromObject.put("headpic", getHeadPic(userid));
        messageObject.put("sendfrom", sendfromObject);

        JSONObject msgObject = new JSONObject();
        msgObject.put("fcontent", fmessage);
        messageObject.put("data", msgObject);

        ArrayList<Long> userids = getImDialogUserIds(timdialogid);
        for (long userid : userids) {
            if (parameter.websocketClients.containsKey(userid)) {
                for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                    webClientSocket.sendDialogMessage(messageObject);
                }
            }
        }
        saveMessage(messageObject, fmessage);
        return getSucReturnObject().toString();
    }

    /**
     * ļϢ
     *
     * @return
     */
    public String sendFileMessage() throws P2Exception {
        long timdialogid = content.getLong("timdialogid");//ԻID
        long tattachmentid = content.getLong("tattachmentid");//ID

        JSONObject messageObject = new JSONObject();
        messageObject.put("timdialogid", timdialogid);
        messageObject.put("ftype", "file");
        messageObject.put("fdatetime", getDateTime_Str());
        messageObject.put("fmessageid", new Encryption().Encode_MD5(siteid + userid + Calendar.getInstance().getTimeInMillis()));

        /**
         * ͷϢ
         */
        JSONObject sendfromObject = new JSONObject();
        sendfromObject.put("userid", userid);
        sendfromObject.put("siteid", siteid);
        sendfromObject.put("username", username);
        sendfromObject.put("headpic", getHeadPic(userid));
        messageObject.put("sendfrom", sendfromObject);
        messageObject.put("data", getAttachmentUrl(tattachmentid));

        ArrayList<Long> userids = getImDialogUserIds(timdialogid);
        for (long userid : userids) {
            if (parameter.websocketClients.containsKey(userid)) {
                for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                    webClientSocket.sendDialogMessage(messageObject);
                }
            }
        }
        saveMessage(messageObject, "null");
        return getSucReturnObject().toString();
    }

    /**
     * Ϣ
     *
     * @return
     */
    public String sendDataMessage() throws P2Exception {
        long timdialogid = content.getLong("timdialogid");//ԻID
        String ownertable = content.getString("ownertable");//ݱ
        long ownerid = content.getLong("ownerid");//ID
        String ftype = content.getString("ftype");//

        JSONObject messageObject = new JSONObject();
        messageObject.put("timdialogid", timdialogid);
        messageObject.put("ftype", "data");
        messageObject.put("fdatetime", getDateTime_Str());
        messageObject.put("fmessageid", new Encryption().Encode_MD5(siteid + userid + Calendar.getInstance().getTimeInMillis()));

        /**
         * ͷϢ
         */
        JSONObject sendfromObject = new JSONObject();
        sendfromObject.put("userid", userid);
        sendfromObject.put("siteid", siteid);
        sendfromObject.put("username", username);
        sendfromObject.put("headpic", getHeadPic(userid));
        messageObject.put("sendfrom", sendfromObject);

        JSONObject msgObject = new JSONObject();
        msgObject.put("ownertable", ownertable);
        msgObject.put("ownerid", ownerid);
        msgObject.put("ftype", ftype);
        messageObject.put("data", msgObject);

        ArrayList<Long> userids = getImDialogUserIds(timdialogid);
        for (long userid : userids) {
            if (parameter.websocketClients.containsKey(userid)) {
                for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                    webClientSocket.sendDialogMessage(messageObject);
                }
            }
        }
        saveMessage(messageObject, "null");
        return getSucReturnObject().toString();
    }

    /**
     * Ϣ־û
     *
     * @param messageObject
     */
    private void saveMessage(JSONObject messageObject, String fnotes) {
        SQLFactory sqlFactory = new SQLFactory(this, "ʱͨѶȺϢ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("fnotes", fnotes);
        sqlFactory.addParameter("timdialogid", messageObject.getLong("timdialogid"));
        sqlFactory.addParameter("tenterprise_userid", userid);
        sqlFactory.addParameter("fmessageobj", messageObject.toJSONString());
        sqlFactory.addParameter("fmessageid", messageObject.getString("messageid"));
        sqlFactory.addParameter("fmessagetype", messageObject.getString("ftype"));
        if ("data".equals(messageObject.getString("ftype"))) {
            sqlFactory.addParameter("ownerid", messageObject.getJSONObject("data").getString("ownerid"));
            sqlFactory.addParameter("ownertable", messageObject.getJSONObject("data").getString("ownertable"));
        } else {
            sqlFactory.addParameter("ownerid", "null");
            sqlFactory.addParameter("ownertable", "null");
        }
        dbConnect.runSqlUpdate(sqlFactory.getSQL());
    }
}
