package p2.pao;

import p2.p2server.P2Server;
import p2.util.DataBindBody;
import p2.util.P2AppException;
import p2.util.P2Exception;
import p2.util.P2Format;
import p2.util.logging.P2Logger;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

/**
 * ڶ̬ݰ󶨵Ĳ
 * 
 */
public class PaoFieldObjectBind extends PaoFieldDataBind {
	String errorGroup;
	String errorKey;
	String foreignlinkWhere;
	/**
	 * ǿư
	 */
	boolean enforceContain;
	/**
	 * ѡԶĿ¼?
	 */
	boolean createDestRecord;
	/**
	 * ɶѡ?
	 */
	boolean multiSelect;
	/**
	 * Դ
	 */
	private String objectName;
	/**
	 * where
	 */
	String listWhere;
	/**
	 * whereб
	 */
	ArrayList conditionalListWhere;
	/**
	 * ԴλĿλǰλӳĻ
	 */
	HashMap<String,String[][]> cachedKeyMapHash;
	/**
	 * ڲҵĶkeywhere
	 */
	String multiKeyWhereForLookup;
	/**
	 * Ƿλÿֵ
	 */
	boolean allAttrsNullable;
    /**
     * Ϊֵλ顣
     */
    String[] notAllowNullAttrs;
	public static final String ISNULL = "0";
	public static final String ISNOTNULL = "1";

	public PaoFieldObjectBind(PaoField mbv) {
		super(mbv);
		errorGroup = "system";
		errorKey = "notvalid";
		foreignlinkWhere = null;
		enforceContain = false;
		createDestRecord = false;
		multiSelect = false;

		setObjectName(null);
		listWhere = null;
		conditionalListWhere = new ArrayList(10);
		cachedKeyMapHash = new HashMap(16);
		multiKeyWhereForLookup = null;
		allAttrsNullable = false;
		notAllowNullAttrs = null;

		sourceFieldVector = new Vector();
		destFieldVector = new Vector();
		nullAllowedVector = new Vector();
		isOrder = new Vector();
		isDesc = new Vector();
		isDataBind = new Vector();
		bindIfDestExist = new Vector();
		bindIfDestNull = new Vector();

		// dataBindBodys = new ArrayList<DataBindBody>();
		dataBindBodyMap = new HashMap<String, DataBindBody>(16);
		overwrittenKeyMap = false;
	}

	@Override
	public void chooseActualListValues() throws P2Exception {
		if (this.databindid == null) {
			return;
		}
		String str1 = getSite();
		c localc;
		if ((localc = getPaoField().getPaoFieldInfo().getDataBindInfo()) == null) {
			localc = getPaoField().getPao().getPaoServer().getP2DBInfoCache().getDataBindInfo(this.databindid);
			getPaoField().getPaoFieldInfo().setDataBindInfo(localc);
		}
		if (localc == null) {
			throw new P2AppException("system", "dataBindNotExist", new String[] { this.databindid });
		}
		setForeignLink(((q) localc).c(str1), ((q) localc).d(str1));
		setListCriteria(((q) localc).d(str1));
		Object localObject;
		setEnforceContain(((r) ((q) localc).a(str1)).c);
		localObject = (r) localc.a(str1);
		setSourceFields(((r) localObject).d);
		setDestinationFields(((r) localObject).e);
		setIsOrder(((r) localObject).g);
		setIsDesc(((r) localObject).h);
		setIsDatabind(((r) localObject).i);
		setNullAllowed(((r) localObject).f);
		setBindIfDestExist(((r) localObject).j);
		setBindIfDestNull(((r) localObject).k);
		setDataBindBodys();
		if (!this.overwrittenKeyMap) {
			setKeyMap(((q) localc).c(str1),
					(String[]) this.destFieldVector.toArray(new String[0]),
					(String[]) this.sourceFieldVector.toArray(new String[0]));
		}
	}

	/**
	 * Get foreignlink PAO set.
	 * 
	 * @param where
	 * @return
	 * @throws P2Exception
	 * 
	 */
	public PaoSetRemote getPaoSet(String where) throws P2Exception {
		return getPaoSet(where, "");
	}

	/**
	 * Get foreignlink PAO set by identifier
	 * 
	 * @param where
	 * @param identifier
	 * @return
	 * @throws P2Exception
	 * 
	 */
	public PaoSetRemote getPaoSet(String where, String identifier) throws P2Exception {
		if (identifier == null) {
            identifier = "";
        }
		if (getPaoField().getPao().isZombie()) {
            return paoField.getPao().getPaoSet("__" + getObjectName() + paoField.getName() + identifier,
                    getObjectName(), (new SqlFormat(getPaoField().getPao(), where)).format());
        } else {
            return paoField.getPao().getPaoSet("__" + getObjectName() + paoField.getName() + identifier,
                    getObjectName(), where);
        }
	}

	/**
	 * Get foreignlink PAO set.
	 * 
	 * @return
	 * @throws P2Exception
	 * 
	 */
	public PaoSetRemote getPaoSet() throws P2Exception {
		return getPaoSet(combineWheres());
	}

	@Override
	public boolean hasList() {
		return true;
	}

	/**
	 * ѡб
	 * 
	 * @param objectName
	 * @param whereClause
	 *            ;֤where
	 */
	public void setForeignLink(String objectName, String whereClause) {
		this.setObjectName(objectName);
		foreignlinkWhere = whereClause;
	}

	/**
	 * ѡбĹ
	 * 
	 * @param listWhere
	 */
	public void setListCriteria(String listWhere) {
		this.listWhere = listWhere;
	}

	/**
	 * ôϢ
	 * 
	 * @param eg
	 * @param ek
	 */
	public void setErrorMessage(String eg, String ek) {
		if (eg != null) {
			errorGroup = eg;
			if (ek != null) {
                errorKey = ek;
            }
		}
	}

	/**
	 * where
	 * 
	 * @return
	 */
	String combineWheres() {
		StringBuffer result = new StringBuffer();
		if (foreignlinkWhere != null && foreignlinkWhere.length() > 0) {
            result.append("(").append(foreignlinkWhere).append(" ) ");
        }
		if (listWhere != null && listWhere.length() > 0) {
			if (result.length() > 0) {
                result.append("AND ");
            }
			result.append("(").append(listWhere).append(" )");
		}
		return result.toString();
	}

	/**
	 * ȡwhere
	 * 
	 * @return
	 */
	public String getListCriteria() {
		return listWhere;
	}

	@Override
	public void setValueFromLookup(PaoRemote sourcePao) throws P2Exception {
		Pao pao = getPaoField().getPao();
		String targetAttrName = getPaoField().getFieldName();
        String[][] cachedKeyMap = getCachedKeyMapFromHash(sourcePao.getName());
		if (cachedKeyMap == null) {
            cachedKeyMap = getMatchingAttrs(sourcePao.getName());
        }
		for (int i = 0; i < cachedKeyMap.length; i++) {
			if (null != dataBindBodyMap && dataBindBodyMap.get(cachedKeyMap[i][1]) != null) {
				// λûйѡݰ󶨵ʱ
				if (!dataBindBodyMap.get(cachedKeyMap[i][1]).isDataBind()) {
                    continue;
                }
				// ĿλڣĿλʱ?,Ŀλڣ򲻰ݣ
				if (!dataBindBodyMap.get(cachedKeyMap[i][1]).isDestFieldExist()
						&& dataBindBodyMap.get(cachedKeyMap[i][1]).isBindIfDestExist()) {
                    continue;
                }
			}

			if (cachedKeyMap[i][0].equalsIgnoreCase(targetAttrName)
					|| !pao.getString(cachedKeyMap[i][0]).equals(sourcePao.getString(cachedKeyMap[i][1]))) {
				// if(((String)
				// bindifDestExist[i]).equals(P2Format.getStoreYesValue()))
				// {

				// ԴλΪֵʱƿֵ=0,
				if (sourcePao.isNull(cachedKeyMap[i][1]) && null != dataBindBodyMap
						&& dataBindBodyMap.get(cachedKeyMap[i][1]) != null
						&& !dataBindBodyMap.get(cachedKeyMap[i][1]).isNullAllowed()) {
                    continue;
                }
				// ĿλΪֵʱĿλΪʱݡ=1
				if (!pao.isNull(cachedKeyMap[i][0]) && null != dataBindBodyMap
						&& dataBindBodyMap.get(cachedKeyMap[i][1]) != null
						&& dataBindBodyMap.get(cachedKeyMap[i][1]).isBindIfDestNull()) {
                    continue;
                }
				pao.setValue(cachedKeyMap[i][0], sourcePao.getString(cachedKeyMap[i][1]), SAMEVALUEVALIDATION);
				// }
			}
		}
	}

	@Override
	public String getMatchingAttr() throws P2Exception {
		return getMatchingAttr(getObjectName());
	}

	@Override
	public String getMatchingAttr(String sourceObjectName) throws P2Exception {
        String[][] cachedKeyMap = getMatchingAttrs(sourceObjectName);
		int i;
		for (i = cachedKeyMap.length - 1; i >= 0 && !getPaoField().getName().equalsIgnoreCase(cachedKeyMap[i][0]); i--) {
        }
		return cachedKeyMap[i][1];
	}

	/**
	 * ԴΪkeyȡλƥӳ顣
	 * 
	 * @param sourceName
	 *            Դ
	 * @return
	 * @throws P2Exception
	 */
	protected String[][] getMatchingAttrs(String sourceName) throws P2Exception {
		Pao pao = getPaoField().getPao();
		String targetAttrName = getPaoField().getName();
        String[][] cachedKeyMap = getCachedKeyMapFromHash(sourceName.toUpperCase());
		if (cachedKeyMap != null) {
            return cachedKeyMap;
        }
        Object[] keyMap = pao.getMatchingAttrs(sourceName.toUpperCase(), getPaoField().getName());
		if (keyMap == null) {
            throw new P2AppException("system", "LookupNeedRegister", new String[] { sourceName, targetAttrName });
        }
		cachedKeyMap = new String[keyMap.length][2];
		int k = 0;
        String[] tmp = new String[keyMap.length];
		for (int i = 0; i < keyMap.length; i++) {
			cachedKeyMap[i][0] = (String) ((Object[]) keyMap[i])[0];
			cachedKeyMap[i][1] = (String) ((Object[]) keyMap[i])[1];
			if (!((Boolean) ((Object[]) keyMap[i])[2]).booleanValue()
					&& !cachedKeyMap[i][0].equalsIgnoreCase(targetAttrName)) {
				tmp[k] = cachedKeyMap[i][0];
				k++;
			}
		}

		for (int index = 0; index < k; index++) {
			if (notAllowNullAttrs == null) {
                notAllowNullAttrs = new String[k];
            }
			notAllowNullAttrs[index] = tmp[index];
		}

		if (notAllowNullAttrs == null) {
            allAttrsNullable = true;
        }
		return cachedKeyMap;
	}

	/**
	 * ԴؼλĿؼλӳ仺УʹԴΪkey档
	 * 
	 * @param targetKeys
	 * @param sourceKeys
	 */
	public void setLookupKeyMapInOrder(String[] targetKeys, String[] sourceKeys) {
		if (targetKeys == null || sourceKeys == null || sourceKeys.length == 0
				|| sourceKeys.length != targetKeys.length) {
			return;
		}
        String[][] cachedKeyMap = new String[targetKeys.length][2];
		for (int i = 0; i < targetKeys.length; i++) {
			cachedKeyMap[i][0] = targetKeys[i];
			cachedKeyMap[i][1] = sourceKeys[i];
		}

		cachedKeyMapHash.put(getObjectName() != null ? ( (getObjectName().toUpperCase())) : "", cachedKeyMap);
	}

	/**
	 * ԴؼλĿؼλӳ仺УʹԴΪkey档
	 * 
	 * @param sourcePaoName
	 * @param targetKeys
	 * @param sourceKeys
	 */
	public void setKeyMap(String sourcePaoName, String[] targetKeys, String[] sourceKeys) {
        String[][] cachedKeyMap = new String[targetKeys.length][2];
		for (int i = 0; i < targetKeys.length; i++) {
			cachedKeyMap[i][0] = targetKeys[i];
			cachedKeyMap[i][1] = sourceKeys[i];
		}

		cachedKeyMapHash.put(sourcePaoName.toUpperCase(), cachedKeyMap);

		overwrittenKeyMap = true;
	}

	/**
	 * ԴؼλĿؼλӳӳ仺УʹԴΪkey档
	 * 
	 * @param map
	 */
	public void setLookupKeyMapInOrder(String[][] map) {
		cachedKeyMapHash.put(getObjectName() != null ? ((getObjectName().toUpperCase())) : "", map);
	}

	/**
	 * Ŀλƿֵ
	 */
	public final void setAllAttrsNullable() {
		allAttrsNullable = true;
	}

	/**
	 * ƿֵλ
	 * 
	 * @param attrs
	 */
	public final void setNotAllowNullAttrs(String[] attrs) {
		notAllowNullAttrs = attrs;
	}

	/**
	 * ڲҵĶkeywhere
	 * 
	 * @param w
	 */
	public void setMultiKeyWhereForLookup(String w) {
		multiKeyWhereForLookup = w;
	}

	/**
	 * ԴΪkeyȡԴλĿλǰλӳ
	 * 
	 * @param sourcePaoName
	 * @return
	 */
	private String[][] getCachedKeyMapFromHash(String sourcePaoName) {
        String[][] map = cachedKeyMapHash
                .get(sourcePaoName != null ? sourcePaoName.toUpperCase() : "");
		if (map == null && cachedKeyMapHash.size() == 1) {
            map = cachedKeyMapHash.get("");
        }
		if (map != null && map.length == 0) {
            map = null;
        }
		return map;
	}

	@Override
	public PaoSetRemote smartFill(String value, boolean exact) throws P2Exception {
		PaoSetRemote retSet = smartFind(value, exact);
		if (retSet == null) {
            return retSet;
        }
		if (retSet.getPao(0) != null && retSet.getPao(1) == null) {
            setValueFromLookup(retSet.getPao(0));
        }
		return retSet;
	}

	public PaoSetRemote smartFillWithoutReset(String value, boolean exact) throws P2Exception {
        String[][] cachedKeyMap = getCachedKeyMapFromHash(getObjectName());
		if (cachedKeyMap == null && getObjectName() != null) {
            cachedKeyMap = getMatchingAttrs(getObjectName());
        }
		PaoSetRemote retSet = getList();
		if (!retSet.getPaoSetInfo().isPersistent()) {
            return null;
        }
		int i;
		for (i = cachedKeyMap.length - 1; i >= 0 && !cachedKeyMap[i][0].equalsIgnoreCase(getPaoField().getName()); i--) {
        }
		Pao thisPao = getPaoField().getPao();
		PaoSetRemote emptySet = thisPao.getPaoServer().getPaoSet(getObjectName(), thisPao.getUserInfo());
		emptySet.setWhere("1=2");
		emptySet.setFlag(8L, true);
		PaoRemote each = null;
		int count = 0;
		PaoRemote lastFound = null;
		for (int j = 0; (each = retSet.getPao(j)) != null; j++) {
			if (exact) {
				if (each.getString(cachedKeyMap[i][0]).equalsIgnoreCase(value)) {
					lastFound = each;
					each.copyWithNoSpecific(emptySet);
					count++;
				}
				continue;
			}
			if (each.getString(cachedKeyMap[i][0]).toUpperCase().indexOf(value.toUpperCase()) != -1) {
				lastFound = each;
				each.copyWithNoSpecific(emptySet);
				count++;
			}
		}

		if (count == 1) {
            setValueFromLookup(thisPao);
        }
		return emptySet;
	}

	@Override
	public PaoSetRemote smartFind(String value, boolean exact) throws P2Exception {
        String[][] cachedKeyMap = getCachedKeyMapFromHash(getObjectName());
		if (cachedKeyMap == null && getObjectName() != null) {
            cachedKeyMap = getMatchingAttrs(getObjectName());
        }
		PaoSetRemote listSet = getList();
		String where = listSet.getCompleteWhere();
		PaoSetRemote retSet = getPaoField().getPao().getPaoServer().getPaoSet(getObjectName(),
				getPaoField().getPao().getUserInfo());
		retSet.setOBJECTDataBindLookup(true);
		retSet.setOwner(listSet.getOwner());
		retSet.setApp(listSet.getApp());
		retSet.setWhere(where);
		retSet.setFlag(8L, true);
		if (!retSet.getPaoSetInfo().isPersistent()) {
            return null;
        }
		int i;
		for (i = cachedKeyMap.length - 1; i >= 0 && !cachedKeyMap[i][0].equalsIgnoreCase(getPaoField().getName()); i--) {
        }
		if (exact) {
			retSet.setQbeExactMatch(true);
			retSet.setQbe(cachedKeyMap[i][1], value);
		} else {
			retSet.setQbeExactMatch(false);
			retSet.setQbeCaseSensitive(false);
			String searchType = getPaoField().getPaoFieldInfo().getSearchType();
			int p2type = getPaoField().getType();
			if (p2type == 8 || p2type == 9 || p2type == 6 || p2type == 7 || p2type == 11) {
                retSet.setQbe(cachedKeyMap[i][1], value);
            } else {
                retSet.setQbe(cachedKeyMap[i][1], value + "%");
            }
		}
		return retSet;
	}

	public PaoSetRemote smartFindWithoutReset(String value, boolean exact) throws P2Exception {
        String[][] cachedKeyMap = getCachedKeyMapFromHash(getObjectName());
		if (cachedKeyMap == null && getObjectName() != null) {
            cachedKeyMap = getMatchingAttrs(getObjectName());
        }
		PaoSetRemote retSet = getList();
		if (!retSet.getPaoSetInfo().isPersistent()) {
            return null;
        }
		int i;
		for (i = cachedKeyMap.length - 1; i >= 0 && !cachedKeyMap[i][0].equalsIgnoreCase(getPaoField().getName()); i--) {
        }
		Pao thisPao = getPaoField().getPao();
		PaoSetRemote emptySet = thisPao.getPaoServer().getPaoSet(getObjectName(), thisPao.getUserInfo());
		emptySet.setWhere("1=2");
		emptySet.setFlag(8L, true);
		PaoRemote each = null;
		int count = 0;
		PaoRemote lastFound = null;
		for (int j = 0; (each = retSet.getPao(j)) != null; j++) {
			if (exact) {
				if (each.getString(cachedKeyMap[i][0]).equalsIgnoreCase(value)) {
					lastFound = each;
					each.copyWithNoSpecific(emptySet);
					count++;
				}
				continue;
			}
			if (each.getString(cachedKeyMap[i][0]).toUpperCase().startsWith(value.toUpperCase())) {
				lastFound = each;
				each.copyWithNoSpecific(emptySet);
				count++;
			}
		}

		return emptySet;
	}

	@Override
	public PaoSetRemote smartFind(String sourceObj, String value, boolean exact) throws P2Exception {
        String[][] cachedKeyMap = getCachedKeyMapFromHash(sourceObj);
		if (cachedKeyMap != null && sourceObj != null) {
            return getPaoField().getPao().smartFindByObjectName(sourceObj, getPaoField().getName(), value, exact,
                    cachedKeyMap);
        }
		if (cachedKeyMap == null) {
            return getPaoField().getPao().smartFindByObjectNameDirect(sourceObj, getPaoField().getName(), value, exact);
        } else {
            return null;
        }
	}

	/**
	 * 
	 * @param field
	 * @param condition
	 *            ,0ΪֵʱӴwhere;1ΪֵʱӴwhere
	 * @param where
	 */
	public void addConditionalListWhere(String field, String condition, String where) {
		conditionalListWhere.add(new String[] { field, condition, where });
	}

	/**
	 * condition list where
	 */
	public void clearConditionalListWhere() {
		conditionalListWhere.clear();
	}

	/**
	 * 
	 * @param conditionalWhereList
	 * @return
	 * @throws P2Exception
	 */
	public String evalConditionalWhere(ArrayList conditionalWhereList) throws P2Exception {
		if (conditionalWhereList == null || conditionalWhereList.isEmpty()) {
            return null;
        }
		StringBuffer sb = new StringBuffer();
		if (!conditionalListWhere.isEmpty()) {
			Iterator it = conditionalListWhere.iterator();
			boolean first = true;
			do {
				if (!it.hasNext()) {
                    break;
                }
				if (!first) {
                    sb.append(" and ");
                } else {
                    first = false;
                }
                String[] cw = (String[]) it.next();
				if ("0".equals(cw[1])) {
					if (getPaoField(cw[0]).isNull()) {
						sb.append("(");
						sb.append(cw[2]);
						sb.append(")");
					}
				} else if ("1".equals(cw[1]) && !getPaoField(cw[0]).isNull()) {
					sb.append("(");
					sb.append(cw[2]);
					sb.append(")");
				}
			} while (true);
		}
		return sb.toString();
	}

	/**
	 * 
	 * 
	 * @param objectName
	 */
	public void setObjectName(String objectName) {
		this.objectName = objectName;
	}

	/**
	 * ȡ
	 * 
	 * @return
	 */
	public String getObjectName() {
		return objectName;
	}

	/**
	 * Ƿǿ֤
	 * 
	 * @return
	 */
	public boolean isEnforceContain() {
		return enforceContain;
	}

	/**
	 * Ƿǿư
	 * 
	 * @param enforceContain
	 */
	public void setEnforceContain(boolean enforceContain) {
		this.enforceContain = enforceContain;
	}

	/**
	 * ǷѡȡʱĿ¼
	 * 
	 * @return
	 */
	public boolean isCreateDestRecord() {
		return createDestRecord;
	}

	/**
	 * ǷѡȡʱĿ¼
	 * 
	 * @param createDestRecord
	 */
	public void setCreateDestRecord(boolean createDestRecord) {
		this.createDestRecord = createDestRecord;
	}

	/**
	 * ǷԶѡ
	 * 
	 * @return
	 */
	public boolean isMultiSelect() {
		return multiSelect;
	}

	/**
	 * Դλ
	 * 
	 * @param fl
	 */
	private void setSourceFields(Vector fl) {
		sourceFieldVector = fl;
	}

	/**
	 * Ŀλ
	 * 
	 * @param fl
	 */
	private void setDestinationFields(Vector fl) {
		destFieldVector = fl;
	}

	/**
	 * ĿλǷƿֵ
	 * 
	 * @param fl
	 */
	private void setNullAllowed(Vector fl) {
		nullAllowedVector = fl;
	}

	/**
	 * ǷԶѡ
	 * 
	 * @param multiSelect
	 */
	private void setMultiSelect(boolean multiSelect) {
		this.multiSelect = multiSelect;
	}

	/**
	 * Ƿ֧
	 * 
	 * @param isOrder
	 */
	private void setIsOrder(Vector isOrder) {
		this.isOrder = isOrder;
	}

	/**
	 * Ƿ
	 * 
	 * @param isDesc
	 */
	private void setIsDesc(Vector isDesc) {
		this.isDesc = isDesc;
	}

	/**
	 * Ƿʵʱ()ԴλݵĿλ
	 * 
	 * @param isDatabind
	 */
	private void setIsDatabind(Vector isDatabind) {
		this.isDataBind = isDatabind;
	}

	/**
	 * ǷĿλʱ
	 * 
	 * @param bindIfDestExist
	 */
	private void setBindIfDestExist(Vector bindIfDestExist) {
		this.bindIfDestExist = bindIfDestExist;
	}

	/**
	 * ǷĿλΪֵ԰
	 * 
	 * @param bindIfDestNull
	 */
	private void setBindIfDestNull(Vector bindIfDestNull) {
		this.bindIfDestNull = bindIfDestNull;
	}

	/**
	 * 鲢ö̬ݰݿⶨڵԴλĿλ
	 * 
	 * @return Ŀλ return true;Ŀλȫ return false;
	 * @throws P2Exception
	 */
	/*
	 * private boolean setDestAndSourceFieldsExist() throws P2Exception { String
	 * dests = ""; String sources = ""; String bindifdestexit = ""; String
	 * bindifdestnull = ""; String bindifsourcenull = ""; PaoSetRemote existSet =
	 * P2Server.getP2Server().getPaoSet("PS_OBJECTCOLS",
	 * P2Server.getP2Server().getSystemUserInfo()); existSet.setQbe("objectname",
	 * paoField.getPao().getName()); for (int i = 0, count = destFieldVector.size();
	 * i < count; i++) { if (destFieldVector.elementAt(i) == null) continue; if
	 * (((String)isDataBind.elementAt(i)).equals(P2Format.getStoreNoValue()))
	 * continue; existSet.setQbe("fieldname", (String)
	 * destFieldVector.elementAt(i)); existSet.reset(); if (existSet.getPao(0) !=
	 * null && !existSet.getPao(0).toBeDeleted()) //
	 * ݿⶨĿĿλҲɾ״̬򱣴λdestFieldExistӦԴλsourceFieldExist {
	 * dests += (String) destFieldVector.elementAt(i) + " "; sources += (String)
	 * sourceFieldVector.elementAt(i) + " "; bindifdestexit += (String)
	 * bindIfDestExist.elementAt(i) + " "; bindifdestnull += (String)
	 * bindIfDestNull.elementAt(i) + " "; bindifsourcenull += (String)
	 * nullAllowedVector.elementAt(i) + " "; } } if (dests.length() >= 1 &&
	 * sources.length() >= 1) { destFieldExist = dests.trim().split(" ");
	 * sourceFieldExist = sources.trim().split(" "); bindifDestExist =
	 * bindifdestexit.split(" "); bindifDestNull = bindifdestnull.split(" ");
	 * bindifSourceNull = bindifsourcenull.split(" "); return true; } return
	 * false;// Ŀλڷfalse }
	 */

	/**
	 * ͨĿλȡԴλ
	 * 
	 * @param destField
	 * @return
	 */
	private String getSourceField(String destField) {
		for (int i = 0, numX = destFieldVector.size(); i < numX; i++) {
			if (destField.equalsIgnoreCase(
					destFieldVector.elementAt(i) == null ? null : destFieldVector.elementAt(i).toString())) {
                return (String) sourceFieldVector.elementAt(i);
            }
		}
		return null;
	}

	@Override
	public PaoSetRemote getList() throws P2Exception {
		resetListValues();
        String[][] cachedKeyMap = getCachedKeyMapFromHash(getObjectName());
		if (listWhere == null && multiKeyWhereForLookup == null && cachedKeyMap == null && getObjectName() != null
				&& P2Server.getP2Server().getP2DBInfoCache().getPaoSetInfo(getObjectName()).getKeyField().length > 1) {
            cachedKeyMap = getMatchingAttrs(getObjectName());
        }
		String w = null;
		if (listWhere != null && listWhere.trim().length() > 0) {
            w = listWhere;
        }
		String cw = evalConditionalWhere(conditionalListWhere);
		if (cw != null && !"".equals(cw.trim())) {
            if (w == null) {
                w = cw;
            } else {
                w = "(" + w + ") and (" + cw + ")";
            }
        }
		if (w == null && multiKeyWhereForLookup != null) {
            w = multiKeyWhereForLookup;
        }
		if (w == null) {
            w = "";
        }
		PaoSetRemote ms = getPaoSet(w, "list");
		ms.setOBJECTDataBindLookup(true);// where
		/*
		 * if (listWhere == null && multiKeyWhereForLookup == null && cachedKeyMap !=
		 * null && cachedKeyMap.length > 1) { String thisAttr = getPaoField().getName();
		 * multiKeyWhereForLookup = null; for (int i = 0; i < cachedKeyMap.length; i++)
		 * if (!cachedKeyMap[i][0].equalsIgnoreCase(thisAttr))
		 * ms.setQbe(cachedKeyMap[i][1],
		 * getPaoField().getPao().getString(cachedKeyMap[i][0])); else
		 * ms.setQbe(cachedKeyMap[i][1], ""); }
		 */
		StringBuilder order_by = new StringBuilder();// 
		for (int i = 0; i < isOrder.size(); i++) {
			if (isOrder.elementAt(i) == null) {
                continue;
            }
			if (isOrder.elementAt(i).equals(P2Format.getStoreYesValue())) {
				if (sourceFieldVector.size() <= i) {
					break;
				}
				if (order_by.length() > 0) {
                    order_by.append(" , ");
                }

				order_by.append(sourceFieldVector.elementAt(i).toString()).append(" ").append(isDesc.elementAt(i).equals(P2Format.getStoreYesValue()) ? "desc" : "");
			}
		}
		if (order_by.length() > 0) {
			ms.setOrderBy(order_by.toString());
			ms.reset();
		}
		return ms;
	}

	/**
	 * ֤ҵֵǷΪĿλǰλֵ ֤ǿư
	 */
	@Override
	public void validate() throws P2Exception {
		if (getPaoField().isNull())// ûһĿλǰλ֤
        {
            return;
        }
        String[][] cachedKeyMap = getCachedKeyMapFromHash(getObjectName());
		if (cachedKeyMap == null && notAllowNullAttrs == null && allAttrsNullable && getObjectName() != null
				&& P2Server.getP2Server().getP2DBInfoCache().getPaoSetInfo(getObjectName()).getKeyField().length > 0) {
            try {
                cachedKeyMap = getMatchingAttrs(getObjectName());
            } catch (P2Exception e) {
                P2Logger l = getPaoField().getPao().getPaoLogger();
                if (l.isWarnEnabled()) {
                    l.warn(e);
                }
            }
        }
		if (!allAttrsNullable && notAllowNullAttrs != null) {
			for (int i = 0; i < notAllowNullAttrs.length; i++) {
				String attr = notAllowNullAttrs[i];
				if (getPaoField(attr).isNull()) {
                    Object[] params = {getPaoField(attr).getColumnTitle(), getPaoField().getColumnTitle()};
					throw new P2AppException("system", "nullBeforeSet", params);
				}
			}

		}

		/*
		 * String sourceField; if (isEnforceContain() && (sourceField =
		 * getSourceField(getPaoField().getName())) != null) {// ǿ֤ resetListValues();
		 * PaoSetRemote msi = getPaoSet(); msi.setOBJECTDataBindLookup(true);
		 * msi.setQbe(sourceField, getPaoField().getString()); msi.reset(); if (msi ==
		 * null || msi.isEmpty()) { if (msi != null) msi.close(); Object params[] = {
		 * paoField.getColumnTitle(), paoField.getCurrentValue().toString() }; throw new
		 * P2AppException(errorGroup, errorKey, params); } else { msi.close(); return; }
		 * }
		 */

		if (isEnforceContain()) {// ǿ֤
			resetListValues();
			PaoSetRemote msi = getPaoSet();
			msi.setOBJECTDataBindLookup(true);
			String sourceField;
			if ((sourceField = getSourceField(getPaoField().getName())) != null) {
                msi.setQbe(sourceField, getPaoField().getString());
            } else if (cachedKeyMap != null && cachedKeyMap.length != 0) {
				for (int k = 0; k < cachedKeyMap.length; k++) {
					if (getPaoField().getName().equalsIgnoreCase(cachedKeyMap[k][0]) && cachedKeyMap[k][1] != null) {
						msi.setQbe(cachedKeyMap[k][1], getPaoField().getString());
						break;
					}
				}
			}
			msi.reset();
			if (msi == null || msi.isEmpty()) {
				if (msi != null) {
                    msi.close();
                }
                Object[] params = {paoField.getColumnTitle(), paoField.getCurrentValue().toString()};
				throw new P2AppException(errorGroup, errorKey, params);
			} else {
				msi.close();
			}
		}
	}

	/**
	 * ִAction
	 */
	@Override
	public void action() throws P2Exception {
		if (sourceFieldVector.isEmpty() || getPaoField().isNull()) {
            return;
        }
		PaoRemote ownerPao = paoField.getPao();

		PaoSetRemote msSourceSet = getPaoSet();
		PaoRemote msSourcePao = null;
		boolean moreThanOne = false;
		if (msSourceSet != null) {
			msSourcePao = msSourceSet.getPao(0);
			if (msSourceSet.getPao(1) != null) {
				PaoSetRemote smartFound = smartFind(getPaoField().getString(), true);
				msSourcePao = smartFound.getPao(0);
				if (smartFound.getPao(1) != null) {
                    moreThanOne = true;
                }
			}
		}
		if (msSourceSet == null || msSourcePao == null) {
            return;
        }
		if (moreThanOne) {
            throw new P2AppException("system", "wrongValidationWhere", new String[] { getPaoField().getName() });
        }
		// ϵͳ̬ݰλб¼ʱλ
		for (int k = 0; k < sourceFieldVector.size(); k++) {
			if (sourceFieldVector.elementAt(k) == null) {
                continue;
            }
			String sourceField = (String) sourceFieldVector.elementAt(k);// Դλ
			String destField = (String) destFieldVector.elementAt(k);// Ŀλ
			// ѡʵʱݡĿλִУǰѭ
			/*
			 * if (((String) isDataBind.elementAt(k)).equals(P2Format.getStoreNoValue()))
			 * continue;
			 */// if not databindexec continue
			// ֤ĿλǷ
			PaoSetRemote destField_col = P2Server.getP2Server().getPaoSet("PS_OBJECTCOLS",
					P2Server.getP2Server().getSystemUserInfo());
			SqlFormat sql = new SqlFormat("objectname=:1 and fieldname=:2");
			sql.setObject(1, "PS_OBJECTCOLS", "objectname", ownerPao.getName());
			sql.setObject(2, "PS_OBJECTCOLS", "fieldname", destField);
			destField_col.setWhere(sql.format());
			destField_col.reset();
			if (destField_col.getPao(0) == null
					|| (destField_col.getPao(0) != null && destField_col.getPao(0).toBeDeleted())) {
				if (bindIfDestExist.elementAt(k).equals(P2Format.getStoreYesValue())) {
                    continue;
                } else {
                    throw new P2AppException("system", "destFieldNotExist", new String[] { destField.toUpperCase() });
                }
			}

			// ԴλΪʱƿֵԴλִСĿλΪֵʱݡΪtrueʱֻĿλΪֵʱŻὫԴλֵ󶨵Ŀλ
			String sourceValue = msSourcePao.getString(sourceField);
			if (sourceValue == null || "".equals(sourceValue.trim())) {
				if (((String) nullAllowedVector.elementAt(k)).equalsIgnoreCase(P2Format.getStoreNoValue())) {
                    continue;// If selected "Allow copy null", and source value
                }
								// is null, exec continue.
			}
			if (bindIfDestNull.elementAt(k).equals(P2Format.getStoreYesValue())
					&& !ownerPao.isNull(destField)) {
				continue;// If selected "Data bind if dest field null", and dest
							// value is not null, exec continue.
			}
			ownerPao.setValue(destField, sourceValue, 2L);// PII-1187
		}

	}

	/**
	 * ԴλĿλVectorϢװDataBindBody
	 * 
	 * @return
	 */
	private void setDataBindBodys() throws P2Exception {
		DataBindBody db = null;
		/*
		 * PaoSetRemote existSet = P2Server.getP2Server().getPaoSet("PS_OBJECTCOLS",
		 * P2Server.getP2Server().getSystemUserInfo());
		 * existSet.setWhere("objectname = '" + paoField.getPao().getName() + "'");
		 * existSet.reset(); Vector<String> existFields = new Vector<String>();
		 * PaoRemote field; for (int j = 0, len = existSet.count(); j < len; j++) {
		 * field = existSet.getPao(j); if (!field.toBeDeleted()) {
		 * existFields.add(field.getString("fieldname")); } }
		 */
		for (int i = 0; i < sourceFieldVector.size(); i++) {
			if (null == dataBindBodyMap) {
                dataBindBodyMap = new HashMap<String, DataBindBody>();
            }
			if (null == sourceFieldVector.elementAt(i)) {
                continue;
            }
			db = new DataBindBody();
			db.setSourceField((String) sourceFieldVector.elementAt(i));
			db.setDataBind(isDataBind.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setDestField((String) destFieldVector.elementAt(i));
			db.setOrder(isOrder.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setDesc(isDesc.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setNullAllowed(nullAllowedVector.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setBindIfDestExist(bindIfDestExist.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setBindIfDestNull(bindIfDestNull.elementAt(i).equals(P2Format.getStoreYesValue()));
			db.setDestFieldExist(false);

			if (!isDataBind.elementAt(i).equals(P2Format.getStoreNoValue())
					&& destFieldVector.elementAt(i) != null) {
				// if (existFields.contains((String) destFieldVector.elementAt(i))) {
				db.setDestFieldExist(getPaoField().getPao().getPaoFieldInfoStatic((String) destFieldVector.elementAt(i)) != null);
			}

			dataBindBodyMap.put((String) sourceFieldVector.elementAt(i), db);
		}
	}

	/**
	 * Դλ
	 */
	Vector sourceFieldVector;
	/**
	 * Ŀλ
	 */
	Vector destFieldVector;
	/**
	 * ƿֵ
	 */
	Vector nullAllowedVector;
	/**
	 * Ƿ
	 */
	Vector isOrder;
	/**
	 * Ƿ
	 */
	Vector isDesc;
	/**
	 * ǷݵĿλ
	 */
	Vector isDataBind;
	/**
	 * Ŀλʱ Ŀλ򱨴ΪtrueʱĿλ򲻰ݡ
	 */
	Vector bindIfDestExist;
	/**
	 * ĿλΪֵʱݡΪtrueʱֻĿλΪֵʱŻὫԴλֵ󶨵Ŀλ
	 */
	Vector bindIfDestNull;
	/**
	 * ǷдkeyMap
	 */
	private boolean overwrittenKeyMap;
	/**
	 * Ŀλдڵļ
	 */
	// private String destFieldExist[];
	/**
	 * ԴλжӦĿλڵļ
	 */
	// private String sourceFieldExist[];
	/**
	 * ĿλдλӦġĿλʱݡֵ
	 */
	// private String bindifDestExist[];
	/**
	 * ĿλдλӦġĿλΪֵʱݡֵ
	 */
	// private String bindifDestNull[];;
	/**
	 * ĿλдλӦġƿֵֵ
	 */
	// private String bindifSourceNull[];

	// private List<DataBindBody> dataBindBodys;
	private HashMap<String, DataBindBody> dataBindBodyMap;

	/**
	 * ѷʹsetDataBindId(String dataBindId)
	 * 
	 * @param databindid
	 */
	@Deprecated
	public void setValueListId(String databindid) {
		setDataBindId(databindid);
	}

	/**
	 * ѷʹgetDataBindId()
	 *
	 */
	@Deprecated
	public String getValueListId() {
		return getDataBindId();
	}
}
